local MinBuild, MaxBuild, Build = 40000, 0, select(4, GetBuildInfo())
if Build < MinBuild or ( MaxBuild > 0 and Build > MaxBuild ) then return end
local AddonName, a = ...
local AddonTitle = select(2, GetAddOnInfo(AddonName))
local PlainAddonTitle = AddonTitle:gsub("|c........", ""):gsub("|r", "")
local L = a.Localize
local s = SpellFlashAddon
local x = SpellFlashAddon.UpdatedVariables

local function SetColor(UseColor, Color, ElseColor)
	if UseColor then
		return Color
	end
	return ElseColor or "Pink"
end

--[[
	White - Default
	Yellow - Limited Time or No Global Cooldown
	Purple - AOE or Positional Damage
	Blue - AOE Debuff
	Orange - Finishing Move
	Aqua - Spell Interrupt, Reflect or Dispel
	Green - Self Buff or Turn Autocast On
	Red - Emergency Mitigation Cooldowns or Turn Autocast Off
	Pink - Optional
]]

-- SpellFlash API: http://wow.curseforge.com/addons/spellflash/pages/api/
-- x.Enemy, x.ActiveEnemy, x.NoCC, x.InInstance, x.InstanceType, x.PetAlive, x.PetActiveEnemy, x.PetNoCC, x.Lag, x.DoubleLag, x.ThreatPercent, x.EnemyDetected, x.ShouldPermanentBuff, x.ShouldTemporaryBuff


local StormridersBattlegarb372 = {
	HeadSlot = 65190--[[Stormrider's Headpiece]],
	ShoulderSlot = 65193--[[Stormrider's Spaulders]],
	ChestSlot = 65192--[[Stormrider's Raiment]],
	LegsSlot = 65191--[[Stormrider's Legguards]],
	HandsSlot = 65189--[[Stormrider's Grips]],
}
local StormridersBattlegarb359 = {
	HeadSlot = 60286--[[Stormrider's Headpiece]],
	ShoulderSlot = 60289--[[Stormrider's Spaulders]],
	ChestSlot = 60287--[[Stormrider's Raiment]],
	LegsSlot = 60288--[[Stormrider's Legguards]],
	HandsSlot = 60290--[[Stormrider's Grips]],
}

if GetRealmName() == "Alexstrasza" and UnitName("player") == "Snfabrch" then return end

local function StormridersBattlegarbCount()
	local count = 0
	for Slot in pairs(StormridersBattlegarb372) do
		if s.Equipped(StormridersBattlegarb372[Slot], Slot) or s.Equipped(StormridersBattlegarb359[Slot], Slot) then
			count = count + 1
		end
	end
	return count
end

local function Buffs()
	if a.GetConfig("Disable_Buff") then return end
	if not s.MainHandItemBuff(nil, 300) then
		if s.Flashable(s.ItemName(6947--[[Instant Poison]])) and a.ItemCastable["Instant Poison"]() then
			s.Flash(s.ItemName(6947--[[Instant Poison]], "Yellow"))
		elseif s.Flashable(s.ItemName(2892--[[Deadly Poison]])) and a.ItemCastable["Deadly Poison"]() then
			s.Flash(s.ItemName(2892--[[Deadly Poison]], "Green"))
		elseif s.Flashable(s.ItemName(3775--[[Crippling Poison]])) and a.ItemCastable["Crippling Poison"]() then
			s.Flash(s.ItemName(3775--[[Crippling Poison]], "Green"))
		elseif s.Flashable(s.ItemName(5237--[[Mind-Numbing Poison]])) and a.ItemCastable["Mind-Numbing Poison"]() then
			s.Flash(s.ItemName(5237--[[Mind-Numbing Poison]], "Green"))
		elseif s.Flashable(s.ItemName(10918--[[Wound Poison]])) and a.ItemCastable["Wound Poison"]() then
			s.Flash(s.ItemName(10918--[[Wound Poison]], "Green"))
		end
	end
	if not s.OffHandItemBuff(nil, 300) then
		if s.Flashable(s.ItemName(2892--[[Deadly Poison]])) and a.ItemCastable["Deadly Poison"]() then
			s.Flash(s.ItemName(2892--[[Deadly Poison]], "Yellow"))
		elseif s.Flashable(s.ItemName(6947--[[Instant Poison]])) and a.ItemCastable["Instant Poison"]() then
			s.Flash(s.ItemName(6947--[[Instant Poison]], "Green"))
		elseif s.Flashable(s.ItemName(3775--[[Crippling Poison]])) and a.ItemCastable["Crippling Poison"]() then
			s.Flash(s.ItemName(3775--[[Crippling Poison]], "Green"))
		elseif s.Flashable(s.ItemName(5237--[[Mind-Numbing Poison]])) and a.ItemCastable["Mind-Numbing Poison"]() then
			s.Flash(s.ItemName(5237--[[Mind-Numbing Poison]], "Green"))
		elseif s.Flashable(s.ItemName(10918--[[Wound Poison]])) and a.ItemCastable["Wound Poison"]() then
			s.Flash(s.ItemName(10918--[[Wound Poison]], "Green"))
		end
	end
end

local function CrowdControl()
	if a.GetConfig("Disable_CC") then return end
	if s.Flashable(2637--[[Hibernate]]) and a.Castable["Hibernate"]() then
		s.Flash(2637--[[Hibernate]], SetColor(x.ActiveEnemy, "Purple"))
	end
	if s.Flashable(339--[[Entangling Roots]]) and a.Castable["Entangling Roots"]() then
		s.Flash(339--[[Entangling Roots]], SetColor(x.ActiveEnemy, "Purple"))
	end
end

local function Survival()
	if a.GetConfig("Disable_Surv") then return end
		if s.TalentMastery(1) then
			if x.ThreatPercent >= 95 then
				if s.Flashable(16689--[[Nature's Grasp]]) and a.Castable["Entangling Roots"]() then
					s.Flash(16689--[[Nature's Grasp]], SetColor(x.ActiveEnemy, "Purple"))
				end
			end
		end
	if s.TalentMastery(2) then
		if s.Form(5487--[[Bear Form]]) then
			if s.HealthPercent("player") < 35 and s.Flashable(22842--[[Frenzied Regeneration]]) and x.NoCC and a.Castable["Frenzied Regeneration"]() then
				s.Flash(22842--[[Frenzied Regeneration]], SetColor(x.ActiveEnemy, "red"))
			end
			if x.ThreatPercent <= 95 then
				if s.Flashable(6795--[[Growl]]) and a.Castable["Entangling Roots"]() then
					s.Flash(6795--[[Growl]], SetColor(x.ActiveEnemy, "Purple"))
				elseif s.Flashable(5209--[[Challenging Roar]]) and a.Castable["Entangling Roots"]() then
					s.Flash(5209--[[Challenging Roar]], SetColor(x.ActiveEnemy, "Purp le"))
				end
			end
			
				if s.Boss() and s.Flashable(22812--[[Barkskin]]) and x.NoCC and s.Boss() and s.HealthPercent("player") < 50 and a.Castable["Barkskin"]() then
					s.Flash(22812--[[Barkskin]], SetColor(x.ActiveEnemy, "Red"))
				elseif s.Flashable(61336--[[Survival Instincts]]) and x.NoCC and s.HealthPercent("player") < 35 and a.Castable["Survival Instincts"]() then
					s.Flash(61336--[[Survival Instincts]], SetColor(x.ActiveEnemy, "Red"))
				elseif s.Flashable(22812--[[Barkskin]]) and x.NoCC and s.HealthPercent("player") < 40 and a.Castable["Barkskin"]() then
					s.Flash(22812--[[Barkskin]], SetColor(x.ActiveEnemy, "Red"))
				end	
		end
		if s.Form(768--[[Cat Form]]) then
			if x.ThreatPercent >= 95 and ( GetNumRaidMembers() > 1 or GetNumPartyMembers() > 0 ) then
				if s.Flashable(8998--[[Cower]]) and x.NoCC and a.Castable["Cower"]() then
					s.Flash(8998--[[Cower]], SetColor(x.ActiveEnemy, "Purple"))
				elseif s.Flashable(16689--[[Nature's Grasp]]) and a.Castable["Entangling Roots"]() then
					s.Flash(16689--[[Nature's Grasp]], SetColor(x.ActiveEnemy, "Purple"))
				end
			end
			if s.Flashable(61336--[[Survival Instincts]]) and x.NoCC and s.HealthPercent("player") < 20 and a.Castable["Survival Instincts"]() then
				s.Flash(61336--[[Survival Instincts]], SetColor(x.ActiveEnemy, "Red"))
			elseif s.Flashable(22812--[[Barkskin]]) and x.NoCC and s.HealthPercent("player") < 20 and a.Castable["Barkskin"]() then
				s.Flash(22812--[[Barkskin]], SetColor(x.ActiveEnemy, "Red"))
			end
		end
	end
end

local function ManaRegen()
	if a.GetConfig("Disable_Mana") then return end
		if not s.Form(768--[[Cat Form]]) or s.Form(5487--[[Bear Form]]) then
			if s.Flashable(29166--[[Innervate]]) and x.NoCC and s.PowerPercent("player") < 70 and a.Castable["Innervate"]() then
				s.Flash(29166--[[Innervate]], SetColor(x.ActiveEnemy, "Aqua"))
			end
		end
end
local function Interrupts()
	if a.GetConfig("Disable_Kick") then return end
		if s.Flashable(1766--[[Kick]]) and x.NoCC and a.Castable["Kick"]() then
			s.Flash(1766--[[Kick]], SetColor(x.ActiveEnemy, "Aqua"))
		end
end

local function Stance()
	if a.GetConfig("Disable_Stance") then return end
	
		if s.TalentMastery(1) then
			if s.HasTalent(24858--[[Moonkin Form]]) and a.Castable["Moonkin Form"]() then
				if s.Flashable(24858--[[Moonkin Form]]) then
					s.Flash(24858--[[Moonkin Form]])
				end
				s.FlashForm(24858--[[Moonkin Form]])
			end
		end
		
		if s.TalentMastery(2) then
			if s.HasTalent(16929--[[Thick Hide]]) and a.Castable["Bear Form"]() then
				if s.Flashable(5487--[[Bear Form]]) then
					s.Flash(5487--[[Bear Form]])
				end
				s.FlashForm(5487--[[Bear Form]])
			elseif a.Castable["Cat Form"]() then
				if s.Flashable(768--[[Cat Form]]) then
					s.Flash(768--[[Cat Form]])
				end
				s.FlashForm(768--[[Cat Form]])
			end
		end
		
end

local function TrashRotation()
	if not a.GetConfig("Enable_Trash") then return end
		local t4cat = (s.BuffStack(90166--[[Strength of the Panther]]) <= 2 or s.BuffDuration(90166--[[Strength of the Panther]], nil, 5))
		
end

-- Use this single spam function and remove the multiple spam table below, or just use the multiple spam table below and leave this function in place.
s.Spam[AddonName] = function() if a.GetConfig("spell_flashing_off") then return end a.RunSpamTable()
	
	CrowdControl()
		Survival()
		ManaRegen()
		Interrupts()
		TrashRotation()
		Stance()
		Buffs()
			
		if s.TalentMastery(1) then
			if s.Form(1784--[[Stealth]]) then
				if s.Flashable(703--[[Garrote]]) and x.NoCC and a.Castable["Garrote"]() then
					s.Flash(703--[[Garrote]], SetColor(x.ActiveEnemy, "Yellow"))
				end
			end
				if s.Buff(32182--[[Heroism]], "player") or s.Buff(2825--[[Bloodlust]], "player") or s.Buff(80353--[[Time Warp]], "player") then
					if s.Flashable(s.ItemName(58145--[[Potion of the Tol'vir]])) and x.NoCC and a.ItemCastable["Potion of the Tol'vir"]() then
						s.Flash(s.ItemName(58145--[[Potion of the Tol'vir]], SetColor(x.ActiveEnemy, "Green")))
					end
				end
			--Overkill  - 58426
			if s.Buff(58426--[[Overkill]], "player") or s.Buff(32182--[[Heroism]], "player") or s.Buff(2825--[[Bloodlust]], "player") or s.Buff(80353--[[Time Warp]], "player") then
				if s.Flashable(79140--[[Vendetta]]) and x.NoCC and a.Castable["Vendetta"]() then
					s.Flash(79140--[[Vendetta]], SetColor(x.ActiveEnemy, "Green"))
				end
			end
			if s.MyDebuffDuration(1943--[[Rupture]], nil, 15) and not s.Buff(32645--[[Envenom]], "player") and not s.Form(1784--[[Stealth]]) then
				if s.Flashable(1856--[[Vanish]]) and x.NoCC and a.Castable["Vanish"]() then
					s.Flash(1856--[[Vanish]], SetColor(x.ActiveEnemy, "Green"))
				end
			end
			if s.Buff(5171--[[Slice and Dice]], "player") and s.MyDebuff(1943--[[Rupture]]) and GetComboPoints("player") >= 5 then
				if s.Flashable(14177--[[Cold Blood]]) and x.NoCC and s.PowerPercent("player") < 60 and a.Castable["Cold Blood"]() then
					s.Flash(14177--[[Cold Blood]], SetColor(x.ActiveEnemy, "Green"))
				end
			end
				if s.HasTalent(14158--[[Murderous Intent]]) and s.HealthPercent("target") < 35 then 
					elseif s.Flashable(703--[[Garrote]]) and x.NoCC and a.Castable["Garrote"]() then
						s.Flash(703--[[Garrote]], SetColor(x.ActiveEnemy, "Yellow"))
					elseif s.Flashable(5171--[[Slice and Dice]]) and x.NoCC and s.PowerPercent("player") > 25 and GetComboPoints("player") >= 4 and s.MyBuffDuration(5171--[[Slice and Dice]], nil, 5) and a.Castable["Slice and Dice"]() then
						s.Flash(5171--[[Slice and Dice]], SetColor(x.ActiveEnemy, "Green"))
					elseif s.Flashable(1943--[[Rupture]]) and x.NoCC and GetComboPoints("player") >= 4 and s.Buff(5171--[[Slice and Dice]], "player") and a.Castable["Rupture"]() then
						s.Flash(1943--[[Rupture]], SetColor(x.ActiveEnemy, "Yellow"))
					elseif s.Flashable(32645--[[Envenom]]) and x.NoCC and GetComboPoints("player") >= 1 and s.Buff(5171--[[Slice and Dice]], "player") and a.Castable["Envenom"]() then
						s.Flash(32645--[[Envenom]], SetColor(x.ActiveEnemy, "Yellow"))
				
					
					elseif s.Flashable(1329--[[Mutilate]]) and x.NoCC and (s.BuffDuration(5171--[[Slice and Dice]], "player") >=8 or GetComboPoints("player") < 1) and a.Castable["Mutilate"]() then
						s.Flash(1329--[[Mutilate]], SetColor(x.ActiveEnemy, "yellow"))
					elseif s.Flashable(1329--[[Mutilate]]) and x.NoCC and not s.MyBuff(5171--[[Slice and Dice]], "player") and a.Castable["Mutilate"]() then
						s.Flash(1329--[[Mutilate]], SetColor(x.ActiveEnemy, "yellow"))
					elseif s.Flashable(33876--[[Mangle(Cat Form)]]) and x.NoCC and s.MyDebuffDuration(33876--[[Mangle(Cat Form)]], nil, 5) and a.Castable["Mangle(Cat Form)"]() then
						s.Flash(33876--[[Mangle(Cat Form)]], SetColor(x.ActiveEnemy, "Yellow"))
					elseif s.Flashable(52610--[[Savage Roar]]) and s.MyDebuff(1079--[[Rip]], nil, 8) and x.NoCC and a.Castable["Savage Roar"]() then
						s.Flash(52610--[[Savage Roar]], SetColor(x.ActiveEnemy, "Green"))
				end
				if s.HasTalent(14158--[[Murderous Intent]]) and s.HealthPercent("target") > 35 then
				end
			
			if not s.HasTalent(14158--[[Murderous Intent]]) then 
				if s.Flashable(5171--[[Slice and Dice]]) and x.NoCC and s.PowerPercent("player") > 25 and GetComboPoints("player") >= 4 and s.MyBuffDuration(5171--[[Slice and Dice]], nil, 5) and a.Castable["Slice and Dice"]() then
					s.Flash(5171--[[Slice and Dice]], SetColor(x.ActiveEnemy, "Green"))
				elseif s.Flashable(1943--[[Rupture]]) and x.NoCC and GetComboPoints("player") >= 4 and a.Castable["Rupture"]() then
					s.Flash(1943--[[Rupture]], SetColor(x.ActiveEnemy, "Yellow"))
				elseif s.Flashable(32645--[[Envenom]]) and x.NoCC and GetComboPoints("player") >= 1 and s.Buff(5171--[[Slice and Dice]], "player") and a.Castable["Envenom"]() then
					s.Flash(32645--[[Envenom]], SetColor(x.ActiveEnemy, "Yellow"))
				
					
				elseif s.Flashable(1329--[[Mutilate]]) and x.NoCC and (s.BuffDuration(5171--[[Slice and Dice]], "player") >=8 or GetComboPoints("player") < 1) and a.Castable["Mutilate"]() then
					s.Flash(1329--[[Mutilate]], SetColor(x.ActiveEnemy, "yellow"))
				elseif s.Flashable(1329--[[Mutilate]]) and x.NoCC and not s.MyBuff(5171--[[Slice and Dice]], "player") and a.Castable["Mutilate"]() then
					s.Flash(1329--[[Mutilate]], SetColor(x.ActiveEnemy, "yellow"))
				elseif s.Flashable(33876--[[Mangle(Cat Form)]]) and x.NoCC and s.MyDebuffDuration(33876--[[Mangle(Cat Form)]], nil, 5) and a.Castable["Mangle(Cat Form)"]() then
					s.Flash(33876--[[Mangle(Cat Form)]], SetColor(x.ActiveEnemy, "Yellow"))
				elseif s.Flashable(52610--[[Savage Roar]]) and s.MyDebuff(1079--[[Rip]], nil, 8) and x.NoCC and a.Castable["Savage Roar"]() then
					s.Flash(52610--[[Savage Roar]], SetColor(x.ActiveEnemy, "Green"))
				end
			end
			
		end
			
		
		if s.TalentMastery(2) then
				if s.Buff(32182--[[Heroism]], "player") or s.Buff(2825--[[Bloodlust]], "player") or s.Buff(80353--[[Time Warp]], "player") then
					if s.Flashable(s.ItemName(58145--[[Potion of the Tol'vir]])) and x.NoCC and a.ItemCastable["Potion of the Tol'vir"]() then
						s.Flash(s.ItemName(58145--[[Potion of the Tol'vir]], SetColor(x.ActiveEnemy, "Green")))
					end
				end
		end
		
		if s.TalentMastery(3) then
				if s.Buff(32182--[[Heroism]], "player") or s.Buff(2825--[[Bloodlust]], "player") or s.Buff(80353--[[Time Warp]], "player") then
					if s.Flashable(s.ItemName(58145--[[Potion of the Tol'vir]])) and x.NoCC and a.ItemCastable["Potion of the Tol'vir"]() then
						s.Flash(s.ItemName(58145--[[Potion of the Tol'vir]], SetColor(x.ActiveEnemy, "Green")))
					end
				end
			if s.Form(1784--[[Stealth]]) then
				if s.Flashable(36554--[[Shadowstep]]) and x.NoCC and a.Castable["Shadowstep"]() then
					s.Flash(36554--[[Shadowstep]], SetColor(x.ActiveEnemy, "White"))
				elseif s.Flashable(8676--[[Ambush]]) and s.Buff(36554--[[Shadowstep]]) and x.NoCC and a.Castable["Ambush"]() then
					s.Flash(8676--[[Ambush]], SetColor(x.ActiveEnemy, "Yellow"))
				elseif s.Flashable(8676--[[Ambush]]) and x.NoCC and a.Castable["Ambush"]() then
					s.Flash(8676--[[Ambush]], SetColor(x.ActiveEnemy, "White"))
				end
			end
			
			if IsShiftKeyDown() then 
					if s.Flashable(16511--[[Hemorrhage]]) and x.NoCC and a.Castable["Hemorrhage"]() then
						s.Flash(16511--[[Hemorrhage]], SetColor(x.ActiveEnemy, "Green"))
					end
			end
			
				if s.HasTalent(14171 --[[Serrated Blades]]) and s.MyDebuff(1943--[[Rupture]]) then
					if not s.MyDebuffDuration(1943--[[Rupture]], nil, 3) and GetComboPoints("player") == 5 then
						if x.NoCC and s.Flashable(2098--[[Eviscerate]]) and a.Castable["Eviscerate"]() then
							s.Flash(2098--[[Eviscerate]], SetColor(x.ActiveEnemy, "Yellow"))
						end
					--elseif s.MyDebuff(1943--[[Rupture]]) and GetComboPoints("player") == 5 then
						--if x.NoCC and s.Flashable(2098--[[Eviscerate]]) and a.Castable["Eviscerate"]() then
							--s.Flash(2098--[[Eviscerate]], SetColor(x.ActiveEnemy, "Yellow"))
						--end
					end
				end
			if not s.Form(1784--[[Stealth]]) then
				if s.Flashable(5171--[[Slice and Dice]]) and x.NoCC and s.PowerPercent("player") > 25 and s.BuffDuration(5171--[[Slice and Dice]], nil, 5) and a.Castable["Slice and Dice"]() then
					s.Flash(5171--[[Slice and Dice]], SetColor(x.ActiveEnemy, "Green"))
				elseif s.Flashable(1943--[[Rupture]]) and x.NoCC and GetComboPoints("player") == 5 and ( s.Boss() or s.HealthPercent() > 10 ) and a.Castable["Rupture"]() then
					s.Flash(1943--[[Rupture]], SetColor(x.ActiveEnemy, "Yellow"))
				elseif s.Flashable(53--[[Backstab]]) and s.MyDebuff(16511--[[Hemorrhage]]) and x.NoCC and a.Castable["Backstab"]() then
						s.Flash(53--[[Backstab]], SetColor(x.ActiveEnemy, "White"))
				elseif s.Flashable(16511--[[Hemorrhage]]) and not s.MyDebuff(16511--[[Hemorrhage]]) and x.NoCC and a.Castable["Hemorrhage"]() then
						s.Flash(16511--[[Hemorrhage]], SetColor(x.ActiveEnemy, "White"))
				elseif s.Flashable(33876--[[Mangle(Cat Form)]]) and x.NoCC and s.MyDebuffDuration(33876--[[Mangle(Cat Form)]], nil, 5) and a.Castable["Mangle(Cat Form)"]() then
					s.Flash(33876--[[Mangle(Cat Form)]], SetColor(x.ActiveEnemy, "Yellow"))
				elseif s.Flashable(52610--[[Savage Roar]]) and s.MyDebuff(1079--[[Rip]], nil, 8) and x.NoCC and a.Castable["Savage Roar"]() then
					s.Flash(52610--[[Savage Roar]], SetColor(x.ActiveEnemy, "Green"))
				end
			end
		end
	
end