local MinBuild, MaxBuild, Build = 40000, 0, select(4, GetBuildInfo())
if Build < MinBuild or ( MaxBuild > 0 and Build > MaxBuild ) then return end
local AddonName, a = ...
local AddonTitle = select(2, GetAddOnInfo(AddonName))
local PlainAddonTitle = AddonTitle:gsub("|c........", ""):gsub("|r", "")
local L = a.Localize
local s = SpellFlashAddon
local x = s.UpdatedVariables

-- SpellFlash API:
-- http://wow.curseforge.com/addons/spellflash/pages/api/

-- Updated variable references:
-- http://wow.curseforge.com/addons/spellflash/pages/api/#w-local-x-spell-flash-addon-updated-variables
-- x.Enemy, x.ActiveEnemy, x.NoCC, x.InInstance, x.InstanceType, x.PetAlive, x.PetActiveEnemy, x.PetNoCC, x.Lag, x.DoubleLag, x.ThreatPercent, x.EnemyDetected, x.ShouldPermanentBuff, x.ShouldTemporaryBuff

-- Spell table references:
-- http://wow.curseforge.com/addons/spellflash/pages/api/#w-s-castable


a.spells["Healthstone"] = {
	Type = "item",
	ID = 5512--[[Healthstone]],
	FlashColor = "Red",
	CheckFirst = function(z)
		return ( x.ActiveEnemy or s.InCombat() ) and s.HealthPercent("player") <= 35
	end,
}

a.spells["Flask of Enhancement"] = {
	Type = "item",
	ID = 58149--[[Flask of Enhancement]],
	Buff = {
		79637--[[Flask of Enhancement]],
	},
	EarlyRefresh = 60,
	BuffUnit = "player",
}

