local MinBuild, MaxBuild, Build = 40000, 0, select(4, GetBuildInfo())
if Build < MinBuild or ( MaxBuild > 0 and Build > MaxBuild ) then return end
local AddonName, a = ...
local AddonTitle = select(2, GetAddOnInfo(AddonName))
local PlainAddonTitle = AddonTitle:gsub("|c........", ""):gsub("|r", "")
local L = a.Localize
local s = SpellFlashAddon
local x = SpellFlashAddon.UpdatedVariables

local function SetColor(UseColor, Color, ElseColor)
	if UseColor then
		return Color
	end
	return ElseColor or "Pink"
end

--[[
	White - Default
	Yellow - Limited Time or No Global Cooldown
	Purple - AOE or Positional Damage
	Blue - AOE Debuff
	Orange - Finishing Move
	Aqua - Spell Interrupt, Reflect or Dispel
	Green - Self Buff or Turn Autocast On
	Red - Emergency Mitigation Cooldowns or Turn Autocast Off
	Pink - Optional
]]

-- SpellFlash API: http://wow.curseforge.com/addons/spellflash/pages/api/
-- x.Enemy, x.ActiveEnemy, x.NoCC, x.InInstance, x.InstanceType, x.PetAlive, x.PetActiveEnemy, x.PetNoCC, x.Lag, x.DoubleLag, x.ThreatPercent, x.EnemyDetected, x.ShouldPermanentBuff, x.ShouldTemporaryBuff


-- Use this single spam function and remove the multiple spam table below, or just use the multiple spam table below and leave this function in place.
s.Spam[AddonName] = function() if a.GetConfig("spell_flashing_off") then return end a.RunSpamTable()
	
	-- Place script here
	
end


-- Use this multiple spam table, or remove this table and use the single spam function above.
a.Spam = {
	
	
	-- Script Setting 1 (will add 2 and 3 later for diff armors.. maybe instead I will just check automatic for it)
	{Title = L["Nabbs Rogue"], -- Place script title here
	Description = L["Spell Priority for Mutilate spec.  \nSnD > Rupture > Envenom with a Garrote opener. \n\nSpell Priority for Combat spec. \nSnD > Rupture > Eviscerate with Revealing Strike at 4cp.\n\n Will add support for tier sets later."], -- Place optional script description here or comment out or remove this line
	Function = function()
	-- x.Enemy, x.ActiveEnemy, x.NoCC, x.InInstance, x.InstanceType, x.PetAlive, x.PetActiveEnemy, x.PetNoCC, x.Lag, x.DoubleLag, x.ThreatPercent
	-- 1784		--[[Stealth]] white
	-- 53		--[[Backstab]] white
	-- 79140	--[[Vendetta]] pink
	-- 1856		--[[Vanish]] pink
	-- 14177	--[[Cold Blood]] pink
	-- 703		--[[Garrote]] aqua
	-- 1766		--[[Kick]] aqua
	-- 57934	--[[Tricks of the Trade]] pink
	-- 74001	--[[Combat Readiness]] red
	-- 5277		--[[Evasion]] red
	-- 1329		--[[Mutilate]] 	 red	
	-- 32645	--[[Envenom]] Orange
	
	
	-- 5171		--[[Slice and Dice]] Orange
	-- 1943		--[[Rupture]] Orange
	-- 84617	--[[Revealing Strike]]
	-- 1752		--[[Sinister Strike]]
	-- 2098		--[[Eviscerate]]
	
	-- still need Expose Armor; Bandits Guile; Adrenaline Rush; Killing Spree; Blade Flurry; Redirect
	
		if s.TalentMastery(1) then  -- ass(mut) build
			
			--kick
			if x.ActiveEnemy and s.Flashable(1766--[[Kick]]) and a.Castable["Kick"]() then
				s.Flash(1766--[[Kick]], "Aqua")
			end
			---- OPENER (garrote if in stealth)
			if x.ActiveEnemy and s.Flashable(703--[[Garrote]]) then
					if  s.Form(1784--[[Stealth]]) then
						s.Flash(703--[[Garrote]], "Aqua")
					end
			end	
			
			-- no cp (combo points less than 1)
			if x.ActiveEnemy and GetComboPoints("player") < 1 then
				if not s.Form(1784--[[Stealth]]) then 
					if  s.HealthPercent() < 35  then
						s.Flash(53--[[Backstab]], SetColor(x.ActiveEnemy))
					end
					if  s.HealthPercent() > 35  then
						s.Flash(1329--[[Mutilate]], SetColor(x.ActiveEnemy))
					end
				end
			end
			
			-- 1/2/3 CP
			if x.ActiveEnemy and GetComboPoints("player") and GetComboPoints("player") < 4 then
				if x.ActiveEnemy and s.Flashable(5171--[[Slice and Dice]]) then
					if not s.MyBuff("Slice and Dice", "player") then
						s.Flash(5171--[[Slice and Dice]], "Orange")
					end
				end
				if x.ActiveEnemy and s.Flashable(32645--[[Envenom]]) then
					if s.MyBuff("Slice and Dice", "player") and not s.MyBuff("Slice and Dice", "player", 3) then
						s.Flash(32645--[[Envenom]], "Orange")
					end
				end
				if x.ActiveEnemy and s.Flashable(1943--[[Rupture]]) then
						if not s.Debuff("Rupture", "target", 3) then
							s.Flash(1943--[[Rupture]], "Orange")
						end
				end
				if s.MyBuff("Slice and Dice", "player", 4) and s.Debuff("Rupture", "target", 4) then
					-- if snd is > 4 AND rupture is > 4 then do the NOCP priority
					if not s.Form(1784--[[Stealth]]) then 
						if  s.HealthPercent() < 35  then
							s.Flash(53--[[Backstab]], SetColor(x.ActiveEnemy))
						end
						if  s.HealthPercent() > 35  then
							s.Flash(1329--[[Mutilate]], SetColor(x.ActiveEnemy))
						end
					end
				end	
			
			end
			--- 4/5 CP
			if x.ActiveEnemy and GetComboPoints("player") > 3 then
				if s.MyBuff("Slice and Dice", "player") then
					s.Flash(32645--[[Envenom]], SetColor(x.ActiveEnemy))	
				else
					s.Flash(5171--[[Slice and Dice]], "Orange")
				end
				if not s.Debuff("Rupture", "target", 3) then
					s.Flash(1943--[[Rupture]], "Orange")					
				end
				if s.MyBuff("Slice and Dice", "player", 4) and s.Debuff("Rupture", "target", 4) then
					s.Flash(32645--[[Envenom]], SetColor(x.ActiveEnemy))
				end
			end
		end	
		
		if s.TalentMastery(2) then  -- combat build
			--kick
			if x.ActiveEnemy and s.Flashable(1766--[[Kick]]) and a.Castable["Kick"]() then
				s.Flash(1766--[[Kick]], "Aqua")
			end
			
			-- Combat Priority 1
			if x.ActiveEnemy and GetComboPoints("player") > 0 then
				if not s.MyBuff("Slice and Dice", "player") or not s.MyBuff("Slice and Dice", "player", 3) then
					s.Flash(5171--[[Slice and Dice]], "Yellow")
				end
			end
			
			-- Combat Priority 2
			-- 84617	--[[Revealing Strike]] @ 4cp
			-- 1943		--[[Rupture]] @ 5cp Maintained
			-- 2098		--[[Eviscerate]] if rupture is solid @ 5cp
			
			
			if x.ActiveEnemy and s.Flashable(84617--[[Revealing Strike]]) and GetComboPoints("player") > 3 and a.Castable["Revealing Strike"]() then
				s.Flash(84617--[[Revealing Strike]], "Red")
			end
			if x.ActiveEnemy and s.Flashable(2098--[[Eviscerate]]) and GetComboPoints("player") > 4 and a.Castable["Eviscerate"]() then
			if s.Debuff("Rupture", "target", 3) then
				
				s.Flash(2098--[[Eviscerate]], "Orange")
			else
				if a.Castable["Rupture"]() then
					s.Flash(1943--[[Rupture]], "Orange")
				end
			end
			end		
				
			-- CP BUILDER
			if x.ActiveEnemy and GetComboPoints("player") < 5 and a.Castable["Sinister Strike"]() then
				s.Flash(1752--[[Sinister Strike]], "White")
			end
			
			
			
		end
		
		if s.TalentMastery(3) then  -- sublety
		
		end
	end},
	
	
	-- Add and remove as many of these table sections ass needed
	--{Title = L["Nabbs Combat"], -- Place script title here
	--Description = L["Spell Priority for Combat spec.  SnD > Rupture > Eviscerate with Revealing Strike at 4cp."], -- Place optional script description here or comment out or remove this line
	--Function = function()
		
		-- Place script here
		
	--end},
	
	
	-- Add and remove as many of these table sections ass needed
	--{Title = L["Script Title"], -- Place script title here
	--Description = L["Script Description"], -- Place optional script description here or comment out or remove this line
	--Function = function()
		
		-- Place script here
		
	--end},
	
	
}

