local AddonName, AddonTable = ...
local L = AddonTable.Localize
local s = SpellFlashAddon

AddonTable.OptionsFrameTemplate = "SPriest_OptionsFrame"
AddonTable.OptionsFrameName = AddonName.."_SpellFlashAddonOptionsFrame"
AddonTable.OptionsFrame = CreateFrame("Frame", AddonTable.OptionsFrameName, nil, AddonTable.OptionsFrameTemplate)

function AddonTable.OptionsFrame.okay()
	s.SetModuleConfig(AddonName, "spell_flashing_off", not _G[AddonTable.OptionsFrameName.."_SpellFlashing"]:GetChecked())
	if type(AddonTable.Spam) == "table" and type(AddonTable.Spam[1]) == "table" and type(AddonTable.Spam[1].Function) == "function" then
		local Value = _G[AddonTable.OptionsFrameName.."_ScriptSlider"]:GetValue()
		if Value == 1 or type(AddonTable.Spam[Value]) ~= "table" or type(AddonTable.Spam[Value].Function) ~= "function" then
			Value = nil
		end
		s.SetModuleConfig(AddonName, "script_number", Value)
	end
end

function AddonTable.OptionsFrame.refresh()
	_G[AddonTable.OptionsFrameName.."_SpellFlashing"]:SetChecked(not s.GetModuleConfig(AddonName, "spell_flashing_off"))
	if type(AddonTable.Spam) == "table" and type(AddonTable.Spam[1]) == "table" and type(AddonTable.Spam[1].Function) == "function" then
		_G[AddonTable.OptionsFrameName.."_ScriptSlider"]:Show()
		_G[AddonTable.OptionsFrameName.."_ScriptSliderTitle"]:Show()
		_G[AddonTable.OptionsFrameName.."_ScriptSliderDescription"]:Show()
		_G[AddonTable.OptionsFrameName.."_ScriptSliderMinValue"]:Show()
		_G[AddonTable.OptionsFrameName.."_ScriptSliderMaxValue"]:Show()
		_G[AddonTable.OptionsFrameName.."_ScriptSliderValue"]:Show()
		local MaxValue = getn(AddonTable.Spam)
		_G[AddonTable.OptionsFrameName.."_ScriptSlider"]:SetMinMaxValues(1, MaxValue)
		_G[AddonTable.OptionsFrameName.."_ScriptSliderMinValueLabel"]:SetText("1")
		_G[AddonTable.OptionsFrameName.."_ScriptSliderMaxValueLabel"]:SetText(""..MaxValue)
		local Value = s.GetModuleConfig(AddonName, "script_number") or 1
		if type(AddonTable.Spam[Value]) ~= "table" or type(AddonTable.Spam[Value].Function) ~= "function" then
			Value = 1
		end
		_G[AddonTable.OptionsFrameName.."_ScriptSlider"]:SetValue(Value)
		_G[AddonTable.OptionsFrameName.."_ScriptSliderTitleLabel"]:SetText(AddonTable.Spam[Value].Title or "")
		_G[AddonTable.OptionsFrameName.."_ScriptSliderDescriptionLabel"]:SetText(AddonTable.Spam[Value].Description or "")
		_G[AddonTable.OptionsFrameName.."_ScriptSliderValueLabel"]:SetText(""..Value)
	end
end

function AddonTable.OptionsFrame.default()
	s.ClearAllModuleConfigs(AddonName)
end

if L["Spell Flashing"] == "Spell Flashing" and SpellFlashAddonOptionsFrame_SpellFlashingText and SpellFlashAddonOptionsFrame_SpellFlashingText:GetText() ~= "Spell Flashing" then
	L["Spell Flashing"] = SpellFlashAddonOptionsFrame_SpellFlashingText:GetText()
end
for _, Frame in next,{AddonTable.OptionsFrame:GetChildren()} do
	if Frame:GetObjectType() == "FontString" then
		local text = Frame:GetText()
		if text and text ~= "" then
			Frame:SetText(L[text])
		end
	else
		for _, Frame in next,{Frame:GetRegions()} do
			if Frame:GetObjectType() == "FontString" then
				local text = Frame:GetText()
				if text and text ~= "" then
					Frame:SetText(L[text])
				end
			end
		end
	end
end
_G[AddonTable.OptionsFrameName.."TitleString"]:SetText(select(2, GetAddOnInfo(AddonName)).." "..GetAddOnMetadata(AddonName, "Version"))

function AddonTable.OptionsFrame.UpdateSliderText(self)
	if self and self:IsVisible() then
		local Value = self:GetValue()
		if type(AddonTable.Spam[Value]) ~= "table" or type(AddonTable.Spam[Value].Function) ~= "function" then
			Value = 1
		end
		_G[AddonTable.OptionsFrameName.."_ScriptSliderTitleLabel"]:SetText(AddonTable.Spam[Value].Title or "")
		_G[AddonTable.OptionsFrameName.."_ScriptSliderDescriptionLabel"]:SetText(AddonTable.Spam[Value].Description or "")
		_G[AddonTable.OptionsFrameName.."_ScriptSliderValueLabel"]:SetText(""..Value)
	end
end

AddonTable.OptionsFrame.parent = select(2, GetAddOnInfo("SpellFlash"))
AddonTable.OptionsFrame.name = select(2, GetAddOnInfo(AddonName))
InterfaceOptions_AddCategory(AddonTable.OptionsFrame)
