local MinBuild, MaxBuild, Build = 40000, 0, select(4, GetBuildInfo())
if Build < MinBuild or ( MaxBuild > 0 and Build > MaxBuild ) then return end
local AddonName, a = ...
local AddonTitle = select(2, GetAddOnInfo(AddonName))
local PlainAddonTitle = AddonTitle:gsub("|c........", ""):gsub("|r", "")
local L = a.Localize
local s = SpellFlashAddon
local x = SpellFlashAddon.UpdatedVariables
local config = {}
config.event = {}


SpellFlash_Druid = {}

function SpellFlash_Druid.AOE(switch)
	if switch == nil then
		a.AOE = not a.AOE
		if a.AOE then
			a.print(L["Multiple Targets"])
		else
			a.print(L["Single Target"])
		end
	else
		a.AOE = switch
	end
end

function SpellFlash_Druid.NotBehind(switch)
	if switch == nil then
		a.NotBehind = not a.NotBehind
		if a.NotBehind then
			a.print(L["Not Behind Target"])
		else
			a.print(L["Behind Target"])
		end
	else
		a.NotBehind = switch
	end
end

BINDING_HEADER_SpellFlash_Druid_HEADER = AddonTitle
BINDING_NAME_SpellFlash_Druid_AOE_Toggle = L["Toggle AOE"]
BINDING_NAME_SpellFlash_Druid_AOE_Press = L["AOE While Pressed"]
BINDING_NAME_SpellFlash_Druid_NotBehind_Toggle = L["Toggle Behind Target"]
BINDING_NAME_SpellFlash_Druid_NotBehind_Press = L["Not Behind Target While Pressed"]


-- Only add this function if a spell has a buff or debuff name that is different than the name of the spell that is cast.
-- This is so travel time can be properly tracked for the spell.
-- Example other auras function:
--function config.OtherAurasFunction()
--	if s.HasTalent(17793--[[Shadow and Flame]]) then
--		s.SetOtherAuras(686--[[Shadow Bolt]], 17800--[[Shadow and Flame]])
--		s.SetOtherAuras(29722--[[Incinerate]], 17800--[[Shadow and Flame]])
--	end
--	if s.HasTalent(32385--[[Shadow Embrace]]) then
--		s.SetOtherAuras(686--[[Shadow Bolt]], 32385--[[Shadow Embrace]])
--		s.SetOtherAuras(48181--[[Haunt]], 32385--[[Shadow Embrace]])
--	end
--	if s.HasTalent(18179--[[Jinx]]) then
--		s.SetOtherAuras(1490--[[Curse of the Elements]], 85547--[[Jinx: Curse of the Elements]])
--	end
--end


-- Event listings:
-- http://wowprogramming.com/docs/events
-- http://www.wowwiki.com/Events_(API)

-- Add as many event functions as needed.
-- Example event function:
--function config.event.EVENT_NAME_GOES_HERE(event, ...)
--	a.print(L["Something happened!"], event, ...)
--end


config.CheckButtonOptions = {
	LeftCheckButton1 = {
		DefaultChecked = true,
		ConfigKey = "Disable_Buff",
		Label = L["Buffs"],
	},
	LeftCheckButton2 = {
		DefaultChecked = true,
		ConfigKey = "Disable_CC",
		Label = L["Crowd Control"],
	},
	LeftCheckButton3 = {
		DefaultChecked = true,
		ConfigKey = "Disable_Surv",
		Label = L["Survival Mode"],
	},
	LeftCheckButton4 = {
		DefaultChecked = true,
		ConfigKey = "Disable_Kick",
		Label = L["Interrupts"],
	},
	LeftCheckButton5 = {
		DefaultChecked = true,
		ConfigKey = "Disable_Stance",
		Label = L["Totem Flashing"],
	},
	LeftCheckButton6 = {
		DefaultChecked = true,
		ConfigKey = "Disable_Mana",
		Label = L["Mana Regen"],
	},
	LeftCheckButton7 = {
		DefaultChecked = true,
		ConfigKey = "My_Config_Key",
		Label = L["My_Check_Button_Label"],
	},
	RightCheckButton1 = {
		DefaultChecked = true,
		ConfigKey = "Disable_Ele",
		Label = L["Elemental DPS"],
	},
	RightCheckButton2 = {
		DefaultChecked = true,
		ConfigKey = "Disable_Enh",
		Label = L["Enhancement DPS"],
	},
	RightCheckButton3 = {
		DefaultChecked = true,
		ConfigKey = "Disable_Resto",
		Label = L["Restoration Proc/CD"],
	},
	RightCheckButton4 = {
		DefaultChecked = true,
		ConfigKey = "My_Config_Key",
		Label = L["My_Check_Button_Label"],
	},
	RightCheckButton5 = {
		DefaultChecked = true,
		ConfigKey = "My_Config_Key",
		Label = L["My_Check_Button_Label"],
	},
	RightCheckButton6 = {
		DefaultChecked = true,
		ConfigKey = "My_Config_Key",
		Label = L["My_Check_Button_Label"],
	},
	RightCheckButton7 = {
		DefaultChecked = false,
		--ConfigKey = "Enable_Trash",
		Label = L["Trash Rotation"],
	},
}


config.SlashCommands = {
	-- Add and remove as many slash commands as needed:
	"/put_slash_command_here",
	"/put_another_slash_command_here",
}

function config.SlashHandler(msg, editbox)
	local msg = msg:lower()
	-- Do something here
end


a.LoadConfigs(config)