local MinBuild, MaxBuild, Build = 40000, 0, select(4, GetBuildInfo())
if Build < MinBuild or ( MaxBuild > 0 and Build > MaxBuild ) then return end
local AddonName, a = ...
local AddonTitle = select(2, GetAddOnInfo(AddonName))
local PlainAddonTitle = AddonTitle:gsub("|c........", ""):gsub("|r", "")
local L = a.Localize
local s = SpellFlashAddon
local x = SpellFlashAddon.UpdatedVariables
local z = {}


-- SpellFlash API: http://wow.curseforge.com/addons/spellflash/pages/api/
-- x.Enemy, x.ActiveEnemy, x.NoCC, x.InInstance, x.InstanceType, x.PetAlive, x.PetActiveEnemy, x.PetNoCC, x.Lag, x.DoubleLag, x.ThreatPercent, x.EnemyDetected, x.ShouldPermanentBuff, x.ShouldTemporaryBuff

-- Crowd Control
a.Castable["Hex"] = function()
	wipe(z)
	z.SpellID = 51514--[[Hex]]
	if UnitExists("focus") and not s.Boss("focus") and ( not s.Debuff(nil, "focus") or s.NoDamageCC("focus") ) then
		z.Unit = "focus"
	end
	--z.NotWhileMoving = 1
	z.EnemyTargetNeeded = 1
	local seconds = s.CastTime(z.SpellID) + s.SpellCooldown(z.SpellID) + x.DoubleLag
	return not s.Boss(z.Unit) and s.CheckIfSpellCastable(z) and ( not s.Debuff(nil, z.Unit) or ( s.NoDamageCC(z.Unit) and not s.ImmunityDebuff(z.Unit, seconds) and not s.BreakOnDamageCC(z.Unit, seconds + 5) ) )
end

a.Castable["Bind Elemental"] = function()
	wipe(z)
	z.SpellID = 76780--[[Bind Elemental]]
	if UnitExists("focus") and not s.Boss("focus") and ( not s.Debuff(nil, "focus") or s.NoDamageCC("focus") ) then
		z.Unit = "focus"
	end
	--z.NotWhileMoving = 1
	z.EnemyTargetNeeded = 1
	local seconds = s.CastTime(z.SpellID) + s.SpellCooldown(z.SpellID) + x.DoubleLag
	return not s.Boss(z.Unit) and s.CheckIfSpellCastable(z) and ( not s.Debuff(nil, z.Unit) or ( s.NoDamageCC(z.Unit) and not s.ImmunityDebuff(z.Unit, seconds) and not s.BreakOnDamageCC(z.Unit, seconds + 5) ) )
end

--Buffs
a.Castable["Lightning Shield"] = function()
	wipe(z)
	z.SpellID = 324--[[Lightning Shield]]
	z.Buff = z.SpellID
	z.BuffUnit = "player"
	return not IsMounted() and ( not IsResting() or s.InCombat() or s.Enemy("target") or s.Enemy("focus") ) and s.CheckIfSpellCastable(z)
end

a.Castable["Earth Shield"] = function()
	wipe(z)
	z.SpellID = 974--[[Earth Shield]]
	z.MyBuff = z.SpellID
	z.BuffUnit  = "raid|range"
	z.EarlyRefresh = 5
	z.NoRangeCheck = 1
	return not IsMounted() and ( not IsResting() or s.InCombat() or s.Enemy("target") or s.Enemy("focus") ) and s.CheckIfSpellCastable(z)
end

a.Castable["Water Shield"] = function()
	wipe(z)
	z.SpellID = 52127--[[Water Shield]]
	z.Buff = z.SpellID
	z.BuffUnit = "player"
	return not IsMounted() and ( not IsResting() or s.InCombat() or s.Enemy("target") or s.Enemy("focus") ) and s.CheckIfSpellCastable(z)
end

a.Castable["Earthliving Weapon"] = function()
	wipe(z)
	z.SpellID = 51730--[[Earthliving Weapon]]
	z.Buff = z.SpellID
	z.BuffUnit = "player"
	return not IsMounted() and ( not IsResting() or s.InCombat() or s.Enemy("target") or s.Enemy("focus") ) and s.CheckIfSpellCastable(z)
end

a.Castable["Windfury Weapon"] = function()
	wipe(z)
	z.SpellID = 8232--[[Windfury Weapon]]
	z.Buff = z.SpellID
	z.BuffUnit = "player"
	return not IsMounted() and ( not IsResting() or s.InCombat() or s.Enemy("target") or s.Enemy("focus") ) and s.CheckIfSpellCastable(z)
end

a.Castable["Flametongue Weapon"] = function()
	wipe(z)
	z.SpellID = 8024--[[Flametongue Weapon]]
	z.Buff = z.SpellID
	z.BuffUnit = "player"
	return not IsMounted() and ( not IsResting() or s.InCombat() or s.Enemy("target") or s.Enemy("focus") ) and s.CheckIfSpellCastable(z)
end

--Totems

a.Castable["Searing Totem"] = function()
	wipe(z)
	z.SpellID = 3599--[[Searing Totem]]
	z.Buff = 77747--[[Totemic Wrath]]
	z.NoRangeCheck = 1
	return s.CheckIfSpellCastable(z)
end

a.Castable["Fire Elemental Totem"] = function()
	wipe(z)
	z.SpellID = 2894--[[Fire Elemental Totem]]
	z.NoRangeCheck = 1
	return s.CheckIfSpellCastable(z)
end

a.Castable["Magma Totem"] = function()
	wipe(z)
	z.SpellID = 8190--[[Magma Totem]]
	z.NoRangeCheck = 1
	return s.CheckIfSpellCastable(z)
end

a.Castable["Flametongue Totem"] = function()
	wipe(z)
	z.SpellID = 8227--[[Flametongue Totem]]
	z.NoRangeCheck = 1
	return s.CheckIfSpellCastable(z)
end

a.Castable["Healing Stream Totem"] = function()
	wipe(z)
	z.SpellID = 5394--[[Healing Stream Totem]]
	z.NoRangeCheck = 1
	return s.CheckIfSpellCastable(z)
end

a.Castable["Wrath of Air Totem"] = function()
	wipe(z)
	z.SpellID = 3738--[[Wrath of Air Totem]]
	z.NoRangeCheck = 1
	return s.CheckIfSpellCastable(z)
end

--Cooldowns

a.Castable["Bloodlust"] = function()
	wipe(z)
	z.SpellID = 2825--[[Bloodlust]]
	z.Buff = z.SpellID
	z.BuffUnit = "player"
	return s.CheckIfSpellCastable(z)
end

a.Castable["Heroism"] = function()
	wipe(z)
	z.SpellID = 32182--[[Heroism]]
	z.Buff = z.SpellID
	z.BuffUnit = "player"
	return s.CheckIfSpellCastable(z)
end

a.Castable["Shamanistic Rage"] = function()
	wipe(z)
	z.SpellID = 30823--[[Shamanistic Rage]]
	z.Buff = z.SpellID
	z.BuffUnit = "player"
	return s.CheckIfSpellCastable(z)
end

a.Castable["Feral Spirit"] = function()
	wipe(z)
	z.SpellID = 51533--[[Feral Spirit]]
	z.NoRangeCheck = 1
	z.NotIfActive = 1
	return s.CheckIfSpellCastable(z)
end

a.Castable["Elemental Mastery"] = function()
	wipe(z)
	z.SpellID = 16166--[[Elemental Mastery]]
	z.Buff = z.SpellID
	z.BuffUnit = "player"
	return s.CheckIfSpellCastable(z)
end

--Interrupts
a.Castable["Wind Shear"] = function()
	wipe(z)
	z.SpellID = 57994--[[Wind Shear]]
	z.MyDebuff = z.SpellID 
	z.EnemyTargetNeeded = 1
	return s.GetCastingOrChanneling(nil, nil, 1) > (s.SpellCooldown(z.SpellID) + x.DoubleLag) and s.CheckIfSpellCastable(z)
end

--Melee

a.Castable["Auto Attack"] = function()
	wipe(z)
	z.SpellID = 6603--[[Auto Attack]]
	z.EnemyTargetNeeded = 1
	z.NotIfActive = 1
	return s.MeleeDistance() and s.CheckIfSpellCastable(z)
end

a.Castable["Stormstrike"] = function()
	wipe(z)
	z.SpellID = 17364--[[Stormstrike]]
	z.EnemyTargetNeeded = 1
	return s.CheckIfSpellCastable(z)
end

a.Castable["Lava Lash"] = function()
	wipe(z)
	z.SpellID = 60103--[[Lava Lash]]
	z.EnemyTargetNeeded = 1
	return s.CheckIfSpellCastable(z)
end

--Spells
a.Castable["Spiritwalker's Grace"] = function()
	wipe(z)
	z.SpellID = 9206--[[Spiritwalker's Grace]]
	z.EnemyTargetNeeded = 1
	z.MyDebuff = z.SpellID
	return s.CheckIfSpellCastable(z)
end

a.Castable["Earth Shock"] = function()
	wipe(z)
	z.SpellID = 8042--[[Earth Shock]]
	z.EnemyTargetNeeded = 1
	z.MyDebuff = z.SpellID
	return s.CheckIfSpellCastable(z)
end

a.Castable["Flame Shock"] = function()
	wipe(z)
	z.SpellID = 8050--[[Flame Shock]]
	z.EnemyTargetNeeded = 1
	z.MyDebuff = z.SpellID
	z.EarlyRefresh = 3
	-- z.CastTime = s.CastTime(z.SpellID) + 3.5
	return s.CheckIfSpellCastable(z)
end

a.Castable["Fire Nova"] = function()
	wipe(z)
	z.SpellID = 1535--[[Fire Nova]]
	z.NoRangeCheck = 1
	z.NotIfActive = 1
	return s.CheckIfSpellCastable(z)
end

a.Castable["Unleash Elements"] = function()
	wipe(z)
	z.SpellID = 73680--[[Unleash Elements]]
	z.EnemyTargetNeeded = 1
	z.MyBuff = {73683--[[Unleash Flame]], 73681--[[Unleash Wind]],}
	return s.CheckIfSpellCastable(z)
end

a.Castable["Lightning Bolt"] = function()
	wipe(z)
	z.SpellID = 403--[[Lightning Bolt]]
	z.EnemyTargetNeeded = 1
	return s.CheckIfSpellCastable(z)
end

a.Castable["Lava Burst"] = function()
	wipe(z)
	z.SpellID = 51505--[[Lava Burst]]
	z.EnemyTargetNeeded = 1
	return s.CheckIfSpellCastable(z)
end

a.Castable["Chain Lightning"] = function()
	wipe(z)
	z.SpellID = 421--[[Chain Lightning]]
	z.EnemyTargetNeeded = 1
	return s.CheckIfSpellCastable(z)
end

a.Castable["Thunderstorm"] = function()
	wipe(z)
	z.SpellID = 51490--[[Thunderstorm]]
	return s.CheckIfSpellCastable(z)
end

--Resto
a.Castable["Riptide"] = function()
	wipe(z)
	z.SpellID = 61295--[[Riptide]]
	return s.CheckIfSpellCastable(z)
end