local MinBuild, MaxBuild, Build = 40000, 0, select(4, GetBuildInfo())
if Build < MinBuild or ( MaxBuild > 0 and Build > MaxBuild ) then return end
local AddonName, a = ...
local AddonTitle = select(2, GetAddOnInfo(AddonName))
local PlainAddonTitle = AddonTitle:gsub("|c........", ""):gsub("|r", "")
local L = a.Localize
local s = SpellFlashAddon
local x = s.UpdatedVariables

-- SpellFlash API: http://wow.curseforge.com/addons/spellflash/pages/api/
-- x.Enemy, x.ActiveEnemy, x.NoCC, x.InInstance, x.InstanceType, x.PetAlive, x.PetActiveEnemy, x.PetNoCC, x.Lag, x.DoubleLag, x.ThreatPercent, x.EnemyDetected, x.ShouldPermanentBuff, x.ShouldTemporaryBuff

-- Use this single spam function and remove the multiple spam table below, or just use the multiple spam table below and leave this function in place.
s.Spam[AddonName] = function()
	
	if s.MeleeDistance() then a:ClearTimer("Charge") end
	
	a.FlashAll(
		"Battle Shout",
		"Commanding Shout",
		"Deadly Calm",
		"Inner Rage",
	nil)
	
	a.Flash(
		"Death Wish",
		"Retaliation",
		"Recklessness",
	nil)
	
	a.Flash(
		"Last Stand",
		"Enraged Regeneration",
		"Shield Wall",
	nil)
	
	a.Flash(
		"Berserker Rage",
		"Pummel",
		"Shield Bash",
		"Concussion Blow",
		"Throwdown",
		"Spell Reflection",
		"Heroic Fury",
	nil)
	
	if a.Flash(
		"Intervene",
		"Charge",
		"Intercept",
		"Heroic Throw",
	nil) then return end
	
	a.FlashAll(
		"Taunt",
		"Demoralizing Shout",
		"Shield Block",
		"Hamstring",
	nil)
	
	if a.AOE then a.Flash(
		"Cleave",
		"Rend - Blood and Thunder",
		"Thunder Clap - AOE",
		"Shockwave",
		"Whirlwind",
		"Sweeping Strikes",
		"Bladestorm",
	nil) return end
	
	if a.Flash(
		"Heroic Strike - Shield Slam",
		"Shield Slam - Heavy Repercussions",
		"Heroic Strike",
		"Slam - Bloodsurge",
		"Victory Rush",
		"Mortal Strike - Lambs to the Slaughter",
		"Overpower",
		"Execute",
		"Rend - Blood",
		"Shield Block - Heavy Repercussions",
		"Shield Slam",
		"Revenge",
		"Bloodthirst",
		"Mortal Strike",
		"Strike",
		"Raging Blow",
		"Berserker Rage - Raging Blow",
		"Colossus Smash",
	nil) then return end
	
	a.FlashAll("Disarm", "Thunder Clap", "Shattering Throw")
	
	if a.Flash("Rend", "Devastate") then return end
		
	a.FlashAll("Slam", "Sunder Armor", "Attack")
	
end

