local MinBuild, MaxBuild, Build = 40000, 0, select(4, GetBuildInfo())
if Build < MinBuild or ( MaxBuild > 0 and Build > MaxBuild ) then return end
local AddonName, a = ...
local AddonTitle = select(2, GetAddOnInfo(AddonName))
local PlainAddonTitle = AddonTitle:gsub("|c........", ""):gsub("|r", "")
local L = a.Localize
local s = SpellFlashAddon
local x = SpellFlashAddon.UpdatedVariables
local config = {}
config.event = {}


a.MeleeClasses = {
	"Death Knight",
	"Hunter",
	"Paladin",
	"Rogue",
	"Shaman",
	"Warrior",
}

a.StrengthAndAgilityBuffs = {
	6673--[[Battle Shout]],
	57330--[[Horn of Winter]],
	93435--[[Roar of Courage]],
	8076--[[Strength of Earth]],
}

a.StaminaBuffs = {
	469--[[Commanding Shout]],
	90364--[[Qiraji Fortitude]],
	21562--[[Power Word: Fortitude]],
	6307--[[Blood Pact]],
}

a.PhysicalDamageReductionDebuffs = {
	702--[[Curse of Weakness]],
	1160--[[Demoralizing Shout]],
	99--[[Demoralizing Roar]],
	24423--[[Demoralizing Screech]],
	26016--[[Vindication]],
}

a.HasteDebuffs = {
	6343--[[Thunder Clap]],
	8042--[[Earth Shock]],
	59921--[[Frost Fever]],
	53695--[[Judgements of the Just]],
	50285--[[Dust Cloud]],
	90314--[[Tailspin]],
}

a.StrAgiStaIntResistBuffs = {
	1126--[[Mark of the Wild]],
	20217--[[Blessing of Kings]],
}

a.ManaBuffs = {
	1459--[[Arcane Brilliance]],
	54424--[[Fel Intelligence]],
}

a.HasteBuffs = {
	90355--[[Ancient Hysteria]],
	80353--[[Time Warp]],
	2825--[[Bloodlust]],
	32182--[[Heroism]],
}

a.Mp5Buffs = {
	19740--[[Blessing of Might]],
	5675--[[Mana Spring Totem]],
	54424--[[Fel Intelligence]],
}

a.AttackPowerBuffs = {
	53138--[[Abomination's Might]],
	19506--[[Trueshot Aura]],
	19740--[[Blessing of Might]],
	30808--[[Unleashed Rage]],
}

a.SpellHasteBuffs = {
	24907--[[Moonkin Aura]],
	15473--[[Shadowform]],
	3738--[[Wrath of Air Totem]],
}

a.MeleeRangedHasteBuffs = {
	53290--[[Hunting Party]],
	55610--[[Improved Icy Talons]],
	8512--[[Windfury Totem]],
}

a.CriticalStrikeBuffs = {
	17007--[[Leader of the Pack]],
	90309--[[Terrifying Roar]],
	24604--[[Furious Howl]],
	51470--[[Elemental Oath]],
	29801--[[Rampage]],
}


-- Only add this function if a spell has a buff or debuff name that is different than the name of the spell that is cast.
-- This is so travel time can be properly tracked for the spell.
-- Example other auras function:
--function config.OtherAurasFunction()
--	if s.HasTalent(17793--[[Shadow and Flame]]) then
--		s.SetOtherAuras(686--[[Shadow Bolt]], 17800--[[Shadow and Flame]])
--		s.SetOtherAuras(29722--[[Incinerate]], 17800--[[Shadow and Flame]])
--	end
--	if s.HasTalent(32385--[[Shadow Embrace]]) then
--		s.SetOtherAuras(686--[[Shadow Bolt]], 32385--[[Shadow Embrace]])
--		s.SetOtherAuras(48181--[[Haunt]], 32385--[[Shadow Embrace]])
--	end
--	if s.HasTalent(18179--[[Jinx]]) then
--		s.SetOtherAuras(1490--[[Curse of the Elements]], 85547--[[Jinx: Curse of the Elements]])
--	end
--end


-- Event listings:
-- http://wowprogramming.com/docs/events
-- http://www.wowwiki.com/Events_(API)

-- Add as many event functions as needed.
-- Example event function:
--function config.event.EVENT_NAME_GOES_HERE(event, ...)
--	a.print(L["Something happened!"], event, ...)
--end


config.CheckButtonOptions = {
	LeftCheckButton1 = {
		DefaultChecked = true,
		ConfigKey = "DisableBuffs",
		Label = L["Buffs"],
	},
	LeftCheckButton2 = {
		DefaultChecked = true,
		ConfigKey = "My_Config_Key",
		Label = L["My_Check_Button_Label"],
	},
	LeftCheckButton3 = {
		DefaultChecked = true,
		ConfigKey = "DisableInterruptsOrReflections",
		Label = L["Interrupts or Reflections"],
	},
	LeftCheckButton4 = {
		DefaultChecked = true,
		ConfigKey = "My_Config_Key",
		Label = L["My_Check_Button_Label"],
	},
	LeftCheckButton5 = {
		DefaultChecked = true,
		ConfigKey = "DisableAggroDumps",
		Label = L["Aggro Dumps"],
	},
	LeftCheckButton6 = {
		DefaultChecked = true,
		ConfigKey = "My_Config_Key",
		Label = L["My_Check_Button_Label"],
	},
	LeftCheckButton7 = {
		DefaultChecked = true,
		ConfigKey = "DisableEmergencySpells",
		Label = L["Emergency Spells"],
	},
	RightCheckButton1 = {
		DefaultChecked = true,
		ConfigKey = "DisableDebuffs",
		Label = L["Debuffs"],
	},
	RightCheckButton2 = {
		DefaultChecked = true,
		ConfigKey = "My_Config_Key",
		Label = L["My_Check_Button_Label"],
	},
	RightCheckButton3 = {
		DefaultChecked = true,
		ConfigKey = "DisableDispelsOrSteals",
		Label = L["Dispels or Steals"],
	},
	RightCheckButton4 = {
		DefaultChecked = true,
		ConfigKey = "My_Config_Key",
		Label = L["My_Check_Button_Label"],
	},
	RightCheckButton5 = {
		DefaultChecked = true,
		ConfigKey = "DisableCrowedControl",
		Label = L["Crowed Control"],
	},
	RightCheckButton6 = {
		DefaultChecked = true,
		ConfigKey = "My_Config_Key",
		Label = L["My_Check_Button_Label"],
	},
	RightCheckButton7 = {
		DefaultChecked = true,
		ConfigKey = "DisableHealthAndPowerRegen",
		Label = L["Health and Power Regen"],
	},
}


config.SlashCommands = {
	-- Add and remove as many slash commands as needed:
	"/put_slash_command_here",
	"/put_another_slash_command_here",
}

function config.SlashHandler(msg, editbox)
	local msg = msg:lower()
	-- Do something here
end


a.LoadConfigs(config)