if not SpellFlashAddon.Class("player", "Paladin") then return end
local MinBuild, MaxBuild, Build = 40000, 0, select(4, GetBuildInfo())
if Build < MinBuild or ( MaxBuild > 0 and Build > MaxBuild ) then return end
local AddonName, a = ...
local AddonTitle = select(2, GetAddOnInfo(AddonName))
local PlainAddonTitle = AddonTitle:gsub("|c........", ""):gsub("|r", "")
local L = a.Localize
local s = SpellFlashAddon
local x = SpellFlashAddon.UpdatedVariables
local z = {}


-- SpellFlash API: http://wow.curseforge.com/addons/spellflash/pages/api/
-- x.Enemy, x.ActiveEnemy, x.NoCC, x.InInstance, x.InstanceType, x.PetAlive, x.PetActiveEnemy, x.PetNoCC, x.Lag, x.DoubleLag, x.ThreatPercent, x.EnemyDetected, x.ShouldPermanentBuff, x.ShouldTemporaryBuff


-- Example function:
a.Castable["English_Spell_Name"] = function()
	wipe(z)
	z.SpellID = GlobalSpellID--[[English_Spell_Name]]   --this is for defining the correct name of the spell
	z.DebuffSlotNeeded = 1   --use this if you want to make sure that a debuff slot is free on the target so that you do not replace other debuffs
	z.Debuff = z.SpellID   --place debuff name or table of names here if the spell has a debuff that may only be on a target once in total from everyone and has a cooldown shorter than the debuff duration
	z.MyDebuff = z.SpellID   --place debuff name or table of names here if the spell has a debuff that may be on the target multiple times by many people and has a cooldown shorter than the debuff duration
	z.Buff = z.SpellID   --place buff name or table of names here if the spell has a buff that may only be on yourself once in total from everyone and has a cooldown shorter than the buff duration
	z.MyBuff = z.SpellID   --place buff name or table of names here if the spell has a buff that may be on the target multiple times by many people and has a cooldown shorter than the buff duration
	z.BuffUnit = "player"   --you will need to use this if the buff or debuff is not applied to your target
	z.Stack = 2   --use this if the buff or debuff requires more than one application
	z.EarlyRefresh = 5   --use this to indicate the buff or debuff early for a desired number of seconds
	z.CastTime = s.CastTime(z.SpellID)   --use this only if you want to replace the spell cast time used for early indication of a buff or debuff
	z.EnemyTargetNeeded = 1   --use this if the spell should have an enemy targeted
	z.TargetThatUsesManaNeeded = 1   --use this if the spell is only useful on a target that uses mana such as mana draining spells
	z.NoRangeCheck = 1   --use this to disable range detection if the spell has a limited range but the detection in this function is not working correctly for the particular spell
	z.NotIfActive = 1   --use this if the spell may be toggled on such as auto attack or on next swing spells, or to disable when casting or channeling, or if the spell has a cooldown
	z.NotWhileMoving = 1   --use this if the spell is not able to be cast while moving
	z.NoPowerCheck = 1   --use this to disable the power checking in this function
	z.EvenIfNotUsable = 1   --use this to disable the usability checking in this function and may be used if currently in the process of completing a prerequisite that will make the spell usable
	z.Unit = "target"   --this should not be used unless the spell is not to be cast on the target
	z.Interrupt = 1   --use this if the target should be casting or channeling an interruptible ability
	return s.CheckIfSpellCastable(z)
end

-- Example function:
a.ItemCastable["English_Item_Name"] = function()
	wipe(z)
	z.ItemID = ItemID--[[English_Item_Name]]   --this is for defining the correct name of the item
	z.DebuffSlotNeeded = 1   --use this if you want to make sure that a debuff slot is free on the target so that you do not replace other debuffs
	z.Debuff = GlobalSpellID--[[English_Spell_Name]]   --place debuff name or table of names here if the item has a debuff that may only be on a target once in total from everyone and has a cooldown shorter than the debuff duration
	z.MyDebuff = GlobalSpellID--[[English_Spell_Name]]   --place debuff name or table of names here if the item has a debuff that may be on the target multiple times by many people and has a cooldown shorter than the debuff duration
	z.Buff = GlobalSpellID--[[English_Spell_Name]]   --place buff name or table of names here if the item has a buff that may only be on yourself once in total from everyone and has a cooldown shorter than the buff duration
	z.MyBuff = GlobalSpellID--[[English_Spell_Name]]   --place buff name or table of names here if the item has a buff that may be on the target multiple times by many people and has a cooldown shorter than the buff duration
	z.BuffUnit = "player"   --you will need to use this if the buff or debuff is not applied to your target
	z.Stack = 2   --use this if the buff or debuff requires more than one application
	z.EarlyRefresh = 5   --use this to indicate the buff or debuff early for a desired number of seconds
	z.CastTime = 0   --use this if the item has a cast time for indication of a buff or debuff early
	z.EnemyTargetNeeded = 1   --use this if the item should have an enemy targeted
	z.TargetThatUsesManaNeeded = 1   --use this if the item is only useful on a target that uses mana such as mana draining items
	z.NoRangeCheck = 1   --use this to disable range detection if the item has a limited range but the detection in this function is not working correctly for the particular item
	z.NoEquipCheck = 1   --use this to disable equippable detection if the item can be equipped but does not need to be
	z.NotIfActive = 1   --use this if the item may be toggled on such as auto attack or on next swing spells, or to disable when casting or channeling, or if the item has a cooldown
	z.NotWhileMoving = 1   --use this if the item is not able to be used while moving
	z.NoPowerCheck = 1   --use this to disable the power checking in this function
	z.EvenIfNotUsable = 1   --use this to disable the usability checking in this function and may be used if currently in the process of completing a prerequisite that will make the item usable
	z.Unit = "target"   --this should not be used unless the item is not to be cast on the target
	z.Interrupt = 1   --use this if the target should be casting or channeling an interruptible ability
	return s.CheckIfItemCastable(z)
end

-- Example function:
a.VehicleCastable["English_Spell_Name"] = function()
	wipe(z)
	z.SpellID = GlobalSpellID--[[English_Spell_Name]]   --this is for defining the correct name of the spell
	z.DebuffSlotNeeded = 1   --use this if you want to make sure that a debuff slot is free on the target so that you do not replace other debuffs
	z.Debuff = z.SpellID   --place debuff name or table of names here if the spell has a debuff that may only be on a target once in total from everyone and has a cooldown shorter than the debuff duration
	z.MyDebuff = z.SpellID   --place debuff name or table of names here if the spell has a debuff that may be on the target multiple times by many people and has a cooldown shorter than the debuff duration
	z.Buff = z.SpellID   --place buff name or table of names here if the spell has a buff that may only be on yourself once in total from everyone and has a cooldown shorter than the buff duration
	z.MyBuff = z.SpellID   --place buff name or table of names here if the spell has a buff that may be on the target multiple times by many people and has a cooldown shorter than the buff duration
	z.BuffUnit = "vehicle"   --you will need to use this if the buff or debuff is not applied to your target
	z.Stack = 2   --use this if the buff or debuff requires more than one application
	z.EarlyRefresh = 5   --use this to indicate the buff or debuff early for a desired number of seconds
	z.CastTime = 0   --use this if the spell has a cast time for indication of a buff or debuff early
	z.EnemyTargetNeeded = 1   --use this if the spell should have an enemy targeted
	z.TargetThatUsesManaNeeded = 1   --use this if the spell is only useful on a target that uses mana such as mana draining spells
	z.NoRangeCheck = 1   --use this to disable range detection if the spell has a limited range but the detection in this function is not working correctly for the particular spell
	z.NotIfActive = 1   --use this if the spell may be toggled on such as auto attack or on next swing spells, or to disable when casting or channeling, or if the spell has a cooldown
	z.NotWhileMoving = 1   --use this if the spell is not able to be cast while moving
	z.NoPowerCheck = 1   --use this to disable the power checking in this function
	z.EvenIfNotUsable = 1   --use this to disable the usability checking in this function and may be used if currently in the process of completing a prerequisite that will make the spell usable
	z.GlobalVehicleCooldownSpell = GlobalSpellID--[[English_Spell_Name]]   -- use this if spell has more than a global cooldown
	z.Unit = "target"   --this should not be used unless the spell is not to be cast on the target
	z.Interrupt = 1   --use this if the target should be casting or channeling an interruptible ability
	return s.CheckIfVehicleSpellCastable(z)
end



----------------- Paladin Buffs -----------------
a.Castable["Blessing of Kings"] = function()
	wipe(z)
	z.SpellID = 20217--[[Blessing of Kings]]
	z.Buff = {
		20217--[[Blessing of Kings]],
		1126--[[Mark of the Wild]],
	}
	z.BuffUnit = "player"
	return s.CheckIfSpellCastable(z)
end
-- Group buff - Always up - both blessing can be active at the same time, but only 1 blessing from you - 2 pallies = 2 Blessings
a.Castable["Blessing of Might"] = function()
	wipe(z)
	z.SpellID = 19740--[[Blessing of Might]]
	z.Buff = {
		19740--[[Blessing of Might]],
		5675--[[Mana Spring Totem]],
		54424--[[Fel Intelligence]],
		53138--[[Abomination's Might]],
		19506--[[Trueshot Aura]],
		30808--[[Unleashed Rage]],
	}
	z.BuffUnit = "player"
	return s.CheckIfSpellCastable(z)
end
-- Group Buff - Always Up - See above "Blessing of kings" for more detail
a.Castable["Seal of Insight"] = function()
	wipe(z)
	z.SpellID = 20165--[[Seal of Insight]]
	z.Buff = {
		20165--[[Seal of Insight]],
		20164--[[Seal of Justice]],
		20154--[[Seal of Righteousness]],
		31801--[[Seal of Truth]],
	}
	z.BuffUnit = "player"
	return s.CheckIfSpellCastable(z)
end
-- Self buff - Always up
a.Castable["Seal of Justice"] = function()
	wipe(z)
	z.SpellID = 20164--[[Seal of Justice]]
	z.Buff = {
		20164--[[Seal of Justice]],
		20165--[[Seal of Insight]],
		20154--[[Seal of Righteousness]],
		31801--[[Seal of Truth]],
	}
	z.BuffUnit = "player"
	return s.CheckIfSpellCastable(z)
end
-- Self buff - Always up
a.Castable["Seal of Righteousness"] = function()
	wipe(z)
	z.SpellID = 20154--[[Seal of Righteousness]]
	z.Buff = {
		20154--[[Seal of Righteousness]],
		20164--[[Seal of Justice]],
		20165--[[Seal of Insight]],
		31801--[[Seal of Truth]],
	}
	z.BuffUnit = "player"
	return s.CheckIfSpellCastable(z)
end
-- Self buff - Always up
a.Castable["Seal of Truth"] = function()
	wipe(z)
	z.SpellID = 31801--[[Seal of Truth]]
	z.Buff = {
		20154--[[Seal of Righteousness]],
		20164--[[Seal of Justice]],
		20165--[[Seal of Insight]],
		31801--[[Seal of Truth]],
	}
	z.BuffUnit = "player"
	return s.CheckIfSpellCastable(z)
end
-- Self buff - Always up
a.Castable["Crusader Aura"] = function()
	wipe(z)
	z.SpellID = 32223--[[Crusader Aura]]
	z.MyBuff = {
		32223--[[Crusader Aura]],
		465--[[Devotion Aura]],
		7294--[[Retribution Aura]],
		19746--[[Concentration Aura]],
		19891--[[Resistance Aura]],
	}
	z.BuffUnit = "player"
	return s.CheckIfSpellCastable(z)
end
-- Group buff - Always Up - Only 1 Aura per Pally, 5 pallies in group = 5 Aura's active
a.Castable["Devotion Aura"] = function()
	wipe(z)
	z.SpellID = 465--[[Devotion Aura]]
	z.MyBuff = {
		465--[[Devotion Aura]],
		32223--[[Crusader Aura]],
		7294--[[Retribution Aura]],
		19746--[[Concentration Aura]],
		19891--[[Resistance Aura]],
	}
	z.BuffUnit = "player"
	return s.CheckIfSpellCastable(z)
end
-- Group buff - Always Up - Only 1 Aura per Pally, 5 pallies in group = 5 Aura's active
a.Castable["Retribution Aura"] = function()
	wipe(z)
	z.SpellID = 7294--[[Retribution Aura]]
	z.MyBuff = {
		32223--[[Crusader Aura]],
		465--[[Devotion Aura]],
		7294--[[Retribution Aura]],
		19746--[[Concentration Aura]],
		19891--[[Resistance Aura]],
	}
	z.BuffUnit = "player"
	return s.CheckIfSpellCastable(z)
end
-- Group buff - Always Up - Only 1 Aura per Pally, 5 pallies in group = 5 Aura's active
a.Castable["Concentration Aura"] = function()
	wipe(z)
	z.SpellID = 19746--[[Concentration Aura]]
	z.MyBuff = {
		32223--[[Crusader Aura]],
		465--[[Devotion Aura]],
		7294--[[Retribution Aura]],
		19746--[[Concentration Aura]],
		19891--[[Resistance Aura]],
	}
	z.BuffUnit = "player"
	return s.CheckIfSpellCastable(z)
end
-- Group buff - Always Up - Only 1 Aura per Pally, 5 pallies in group = 5 Aura's active
a.Castable["Resistance Aura"] = function()
	wipe(z)
	z.SpellID = 19891--[[Resistance Aura]]
	z.MyBuff = {
		32223--[[Crusader Aura]],
		465--[[Devotion Aura]],
		7294--[[Retribution Aura]],
		19746--[[Concentration Aura]],
		19891--[[Resistance Aura]],
	}
	z.BuffUnit = "player"
	return s.CheckIfSpellCastable(z)
end
-- Group buff - Always Up - Only 1 Aura per Pally, 5 pallies in group = 5 Aura's active
a.Castable["Righteous Fury"] = function()
	wipe(z)
	z.SpellID = 25780--[[Righteous Fury]]
	z.Buff = z.SpellID
	z.BuffUnit = "player"
	return s.CheckIfSpellCastable(z)
end
-- Threat Generation buff - Self Buff - "Talentrank 2" (Your Prot spec) Increases your threat generation while active, making you a more effective tank.  Lasts until cancelled.

----------------- Paladin Deuffs -----------------

----------------- Paladin Interrupts or Reflections -----------------
a.Castable["Rebuke"] = function()
	wipe(z)
	z.SpellID = 85285--[[Rebuke]]
	z.EnemyTargetNeeded = 1
	z.Interrupt = 1
	return s.CheckIfSpellCastable(z)
end
a.Castable["Avenger's Shield"] = function()
	wipe(z)
	z.SpellID = 31935--[[Avenger's Shield]]
	z.EnemyTargetNeeded = 1
	z.Interrupt = 1
	return s.CheckIfSpellCastable(z)
end
a.Castable["Hammer of Justice"] = function()
	wipe(z)
	z.SpellID = 853--[[Hammer of Justice]]
	z.EnemyTargetNeeded = 1
	z.Interrupt = 1
	return s.CheckIfSpellCastable(z)
end

----------------- Paladin Dispels or Steals -----------------

----------------- Paladin Aggro Dumps -----------------

----------------- Paladin Crowed Control -----------------

----------------- Paladin Emergency Spells -----------------

----------------- Paladin Health and Power Regen -----------------



