if not SpellFlashAddon.Class("player", "Druid") then return end
local MinBuild, MaxBuild, Build = 40000, 0, select(4, GetBuildInfo())
if Build < MinBuild or ( MaxBuild > 0 and Build > MaxBuild ) then return end
local AddonName, a = ...
local AddonTitle = select(2, GetAddOnInfo(AddonName))
local PlainAddonTitle = AddonTitle:gsub("|c........", ""):gsub("|r", "")
local L = a.Localize
local s = SpellFlashAddon
local x = SpellFlashAddon.UpdatedVariables

local function SetColor(UseColor, Color, ElseColor)
	if UseColor then
		return Color
	end
	return ElseColor or "Pink"
end

--[[
	White - Default
	Yellow - Limited Time or No Global Cooldown
	Purple - AOE or Positional Damage
	Blue - AOE Debuff
	Orange - Finishing Move
	Aqua - Spell Interrupt, Reflect or Dispel
	Green - Self Buff or Turn Autocast On
	Red - Emergency Mitigation Cooldowns or Turn Autocast Off
	Pink - Optional
]]

-- SpellFlash API: http://wow.curseforge.com/addons/spellflash/pages/api/
-- x.Enemy, x.ActiveEnemy, x.NoCC, x.InInstance, x.InstanceType, x.PetAlive, x.PetActiveEnemy, x.PetNoCC, x.Lag, x.DoubleLag, x.ThreatPercent, x.EnemyDetected, x.ShouldPermanentBuff, x.ShouldTemporaryBuff



-- Use this single spam function and remove the multiple spam table below, or just use the multiple spam table below and leave this function in place.
s.Spam[AddonName] = function() if s.GetModuleConfig(AddonName, "spell_flashing_off") then return end a.RunSpamTable()
	
	if not s.GetModuleConfig(AddonName, "DisableBuffs") then
		if s.Flashable(1126--[[Mark of the Wild]]) and a.Castable["Mark of the Wild"]() then
			s.Flash(1126--[[Mark of the Wild]], "Green")
		end
	end
	
	if not s.GetModuleConfig(AddonName, "DisableDebuffs") then
		
	end
	
	if not s.GetModuleConfig(AddonName, "DisableInterruptsOrReflections") then
		if s.Form(5487--[[Bear Form]]) then
			if s.Flashable(80964--[[Skull Bash(Bear Form)]]) and x.NoCC and a.Castable["Skull Bash(Bear Form)"]() then
				s.Flash(80964--[[Skull Bash(Bear Form)]], SetColor(x.ActiveEnemy, "Aqua"))
			elseif s.Flashable(5211--[[Bash]]) and not s.Boss() and x.NoCC and a.Castable["Bash"]() then
				s.Flash(5211--[[Bash]], SetColor(x.ActiveEnemy, "Aqua"))
			end
		elseif s.Form(768--[[Cat Form]]) then
			if s.Flashable(80965--[[Skull Bash(Cat Form)]]) and x.NoCC and a.Castable["Skull Bash(Cat Form)"]() then
				s.Flash(80965--[[Skull Bash(Cat Form)]], SetColor(x.ActiveEnemy, "Aqua"))
			end
		end
	end
	
	if not s.GetModuleConfig(AddonName, "DisableDispelsOrSteals") then
		
	end
	
	if not s.GetModuleConfig(AddonName, "DisableAggroDumps") then
		
	end
	
	if not s.GetModuleConfig(AddonName, "DisableCrowedControl") then
		
	end
	
	if not s.GetModuleConfig(AddonName, "DisableEmergencySpells") then
		
	end
	
	if not s.GetModuleConfig(AddonName, "DisableHealthAndPowerRegen") then
		
	end
	
end

