if not SpellFlashAddon.Class("player", "Warrior") then return end
local MinBuild, MaxBuild, Build = 40000, 0, select(4, GetBuildInfo())
if Build < MinBuild or ( MaxBuild > 0 and Build > MaxBuild ) then return end
local AddonName, a = ...
local AddonTitle = select(2, GetAddOnInfo(AddonName))
local PlainAddonTitle = AddonTitle:gsub("|c........", ""):gsub("|r", "")
local L = a.Localize
local s = SpellFlashAddon
local x = SpellFlashAddon.UpdatedVariables

local function SetColor(UseColor, Color, ElseColor)
	if UseColor then
		return Color
	end
	return ElseColor or "Pink"
end

--[[
	White - Default
	Yellow - Limited Time or No Global Cooldown
	Purple - AOE or Positional Damage
	Blue - AOE Debuff
	Orange - Finishing Move
	Aqua - Spell Interrupt, Reflect or Dispel
	Green - Self Buff or Turn Autocast On
	Red - Emergency Mitigation Cooldowns or Turn Autocast Off
	Pink - Optional
]]

-- SpellFlash API: http://wow.curseforge.com/addons/spellflash/pages/api/
-- x.Enemy, x.ActiveEnemy, x.NoCC, x.InInstance, x.InstanceType, x.PetAlive, x.PetActiveEnemy, x.PetNoCC, x.Lag, x.DoubleLag, x.ThreatPercent, x.EnemyDetected, x.ShouldPermanentBuff, x.ShouldTemporaryBuff



-- Use this single spam function and remove the multiple spam table below, or just use the multiple spam table below and leave this function in place.
s.Spam[AddonName] = function() if s.GetModuleConfig(AddonName, "spell_flashing_off") then return end a.RunSpamTable()
	
	if not s.GetModuleConfig(AddonName, "DisableBuffs") then
		if s.Flashable(6673--[[Battle Shout]]) and a.Castable["Battle Shout"](1) then
			s.Flash(6673--[[Battle Shout]], "Green")
		end
		if s.Flashable(469--[[Commanding Shout]]) and a.Castable["Commanding Shout"](1) then
			s.Flash(469--[[Commanding Shout]], "Green")
		end
	end
	
	if not s.GetModuleConfig(AddonName, "DisableDebuffs") then
		if x.ActiveEnemy and s.Flashable(1715--[[Hamstring]]) and a.Castable["Hamstring"]() then
			s.Flash(1715--[[Hamstring]], "Yellow")
		elseif x.NoCC and s.Flashable(772--[[Rend]]) and a.Castable["Rend"]() then
			s.Flash(772--[[Rend]], SetColor(x.ActiveEnemy))
		end
		if x.ActiveEnemy and s.Flashable(1160--[[Demoralizing Shout]]) and a.Castable["Demoralizing Shout"]() then
			s.Flash(1160--[[Demoralizing Shout]], "Blue")
		end
		if x.ActiveEnemy and s.Flashable(6343--[[Thunder Clap]]) and a.Castable["Thunder Clap"]() then
			s.Flash(6343--[[Thunder Clap]], "Purple")
		end
		if x.ActiveEnemy and s.Flashable(676--[[Disarm]]) and a.Castable["Disarm"]() then
			if not s.Player() then
				s.Flash(676--[[Disarm]], "Pink")
			elseif s.Class(nil, a.MeleeClasses) then
				s.Flash(676--[[Disarm]], "Aqua")
			end
		end
	end
	
	if not s.GetModuleConfig(AddonName, "DisableInterruptsOrReflections") then
		if s.Flashable(6552--[[Pummel]]) and a.Castable["Pummel"]() then
			s.Flash(6552--[[Pummel]], SetColor(x.ActiveEnemy, "Aqua"))
		elseif s.Flashable(72--[[Shield Bash]]) and a.Castable["Shield Bash"]() then
			s.Flash(72--[[Shield Bash]], SetColor(x.ActiveEnemy, "Aqua"))
		elseif s.Flashable(12809--[[Concussion Blow]]) and a.Castable["Concussion Blow"]() then
			s.Flash(12809--[[Concussion Blow]], SetColor(x.ActiveEnemy, "Aqua"))
		elseif s.Flashable(85388--[[Throwdown]]) and a.Castable["Throwdown"]() then
			s.Flash(85388--[[Throwdown]], SetColor(x.ActiveEnemy, "Aqua"))
		elseif s.Flashable(23920--[[Spell Reflection]]) and a.Castable["Spell Reflection"]() then
			s.Flash(23920--[[Spell Reflection]], "Aqua")
		end
	end
	
	if not s.GetModuleConfig(AddonName, "DisableDispelsOrSteals") then
		if s.Flashable(60970--[[Heroic Fury]]) and a.Castable["Heroic Fury"]() then
			s.Flash(60970--[[Heroic Fury]], "Aqua")
		end
	end
	
	if not s.GetModuleConfig(AddonName, "DisableAggroDumps") then
		
	end
	
	if not s.GetModuleConfig(AddonName, "DisableCrowedControl") then
		
	end
	
	if not s.GetModuleConfig(AddonName, "DisableEmergencySpells") then
		if s.Flashable(12975--[[Last Stand]]) and a.Castable["Last Stand"]() then
			s.Flash(12975--[[Last Stand]], "Red")
		elseif s.Flashable(55694--[[Enraged Regeneration]]) and a.Castable["Enraged Regeneration"]() then
			s.Flash(55694--[[Enraged Regeneration]], "Red")
		elseif s.Flashable(871--[[Shield Wall]]) and a.Castable["Shield Wall"]() then
			s.Flash(871--[[Shield Wall]], "Red")
		end
	end
	
	if not s.GetModuleConfig(AddonName, "DisableHealthAndPowerRegen") then
		if s.Flashable(6673--[[Battle Shout]]) and a.Castable["Battle Shout"]() then
			s.Flash(6673--[[Battle Shout]], "Yellow")
		end
		if s.Flashable(469--[[Commanding Shout]]) and a.Castable["Commanding Shout"]() then
			s.Flash(469--[[Commanding Shout]], "Yellow")
		end
	end
	
end

