local MinBuild, MaxBuild, Build = 40000, 0, select(4, GetBuildInfo())
if Build < MinBuild or ( MaxBuild > 0 and Build > MaxBuild ) then return end
local AddonName, AddonTable = ...
local L = AddonTable.Localize
local s = SpellFlashAddon
local a = AddonTable
local x = SpellFlashAddon.UpdatedVariables

local function SetColor(UseColor, Color, ElseColor)
	if UseColor then
		return Color
	end
	return ElseColor or "Pink"
end

--[[
	White - Default
	Yellow - Limited Time or No Global Cooldown
	Purple - AOE or Positional Damage
	Blue - AOE Debuff
	Orange - Finishing Move
	Aqua - Spell Interrupt, Reflect or Dispel
	Green - Self Buff or Turn Autocast On
	Red - Emergency Mitigation Cooldowns or Turn Autocast Off
	Pink - Optional
]]

local function PetStance()
	if s.GetModuleConfig(AddonName, "Disable_PetStance") then return end
		if x.PetAlive then
		
		if s.HasSpell(93321--[[Control Pet]]) then
			if x.ActiveEnemy and not x.PetActiveEnemy then
				s.FlashPet("Attack", "Pink")
			elseif x.PetActiveEnemy and not UnitPlayerControlled("pettarget") and not UnitExists("pettargettarget") and s.HealthPercent("pettarget") <= 25 then
				s.FlashPet("Follow")
			elseif not x.PetNoCC then
				s.FlashPet("Stay")
			end
		end
		
	end
end

local HealingClasses = {
	"Druid",
	"Paladin",
	"Priest",
	"Shaman",
}

local function EnoughForKillCommand(SpellName)
	return not s.TalentMastery(1) or not UnitExists("pettarget") or not s.Flashable(34026--[[Kill Command]]) or s.Power("player") >= (s.SpellCost(34026--[[Kill Command]]) + s.SpellCost(SpellName))
end

-- Use this single spam function and remove the multiple spam table below, or just use the multiple spam table below and leave this function in place.
s.Spam[AddonName] = function() if s.GetModuleConfig(AddonName, "spell_flashing_off") then return end a.RunSpamTable()
	
	-- Place script here
	
end

-- Use this multiple spam table, or remove this table and use the single spam function above.
AddonTable.Spam = {
	
		-- Add and remove as many of these table sections ass needed
	{Title = L["Exalter's Hunter"], -- Place script title here
	Description = L["The creator of SF: Druid and SF: Priest's version of SF: Hunter"], -- Place optional script description here or comment out or remove this line
	Function = function()
		-- x.Enemy, x.ActiveEnemy, x.NoCC, x.InInstance, x.InstanceType, x.PetAlive, x.PetActiveEnemy, x.PetNoCC, x.Lag, x.DoubleLag, x.ThreatPercent
		
		if s.Flashable(34490--[[Silencing Shot]]) and a.Castable["Silencing Shot"]() then
			s.Flash(34490--[[Silencing Shot]], "Aqua")
		elseif x.ActiveEnemy and s.Flashable(19503--[[Scatter Shot]]) and a.Castable["Scatter Shot"]() then
			if s.GetCastingOrChanneling(nil, nil, 1) > (s.SpellCooldown(19503--[[Scatter Shot]]) + x.DoubleLag) then
				s.Flash(19503--[[Scatter Shot]], "Aqua")
			elseif s.MeleeDistance() and not s.Feared() and not s.Rooted() then
				s.Flash(19503--[[Scatter Shot]], "Yellow")
			end
		end
		
		if s.TalentMastery(1) then
			if x.ActiveEnemy and s.Flashable(3045--[[Rapid Fire]]) and a.Castable["Rapid Fire"]() then
			s.Flash(3045--[[Rapid Fire]], "Green")
			elseif x.ActiveEnemy and s.Flashable(23989--[[Readiness]]) and not s.Buff(3045--[[Rapid Fire]], "player") and a.Castable["Readiness"]() then
			s.Flash(23989--[[Readiness]], "Green")
		end
		if s.Flashable(82692--[[Focus Fire]]) and a.Castable["Focus Fire"]() then
			s.Flash(82692--[[Focus Fire]], "Yellow")
		end
		if x.ActiveEnemy and s.Flashable(82726--[[Fervor]]) and a.Castable["Fervor"]() then
			s.Flash(82726--[[Fervor]], "Yellow")
		end
		if x.ActiveEnemy and s.Form(13165--[[Aspect of the Hawk]]) and a.Castable["Aspect of the Fox"]() then
			if s.Flashable(82661--[[Aspect of the Fox]]) then
				s.Flash(82661--[[Aspect of the Fox]], "Pink")
			end
			s.FlashForm(82661--[[Aspect of the Fox]], "Pink")
		elseif ( not s.Form() or ( x.ActiveEnemy and s.Form(82661--[[Aspect of the Fox]]) ) ) and a.Castable["Aspect of the Hawk"]() then
			if s.Flashable(13165--[[Aspect of the Hawk]]) then
				s.Flash(13165--[[Aspect of the Hawk]], SetColor(not s.Form(), "Green"))
			end
			s.FlashForm(13165--[[Aspect of the Hawk]], SetColor(not s.Form(), "Green"))
		end
			
	if ( not x.NoCC or not UnitIsPlayer(s.UnitSelection()) ) and not s.InCombat() and s.Flashable(1130--[[Hunter's Mark]]) and a.Castable["Hunter's Mark"]() then
			s.Flash(1130--[[Hunter's Mark]])
		elseif s.Flashable(19434--[[Aimed Shot]]) and a.Castable["Aimed Shot"]() then
			s.Flash(19434--[[Aimed Shot]], SetColor(x.ActiveEnemy))
		elseif x.NoCC and s.Flashable(5116--[[Concussive Shot]]) and a.Castable["Concussive Shot"]() then
			s.Flash(5116--[[Concussive Shot]], SetColor(x.ActiveEnemy))
		elseif x.NoCC and s.Flashable(53209--[[Chimera Shot]]) and a.Castable["Chimera Shot"]() then
			s.Flash(53209--[[Chimera Shot]], SetColor(x.ActiveEnemy))
		elseif x.NoCC and s.HasTalent(53295--[[Noxious Stings]]) and s.Flashable(1978--[[Serpent Sting]]) and a.Castable["Serpent Sting"]() then
			s.Flash(1978--[[Serpent Sting]], SetColor(x.ActiveEnemy))
		elseif x.NoCC and s.Flashable(53351--[[Kill Shot]]) and a.Castable["Kill Shot"]() then
			s.Flash(53351--[[Kill Shot]], SetColor(x.ActiveEnemy))
		elseif x.NoCC and s.Flashable(53301--[[Explosive Shot]]) and a.Castable["Explosive Shot"]() then
			s.Flash(53301--[[Explosive Shot]], SetColor(x.ActiveEnemy))
		else
			if s.Flashable(34026--[[Kill Command]]) and x.PetNoCC and a.Castable["Kill Command"]() then
				if s.TalentMastery(1) then
					s.Flash(34026--[[Kill Command]], SetColor(x.PetActiveEnemy, "Yellow"))
				else
					s.Flash(34026--[[Kill Command]], SetColor(x.PetActiveEnemy))
				end
			end
			if x.NoCC and s.Flashable(19306--[[Counterattack]]) and a.Castable["Counterattack"]() then
				s.Flash(19306--[[Counterattack]], SetColor(x.ActiveEnemy))
			elseif x.NoCC and s.Flashable(2974--[[Wing Clip]]) and a.Castable["Wing Clip"]() then
				s.Flash(2974--[[Wing Clip]], SetColor(x.ActiveEnemy))
			else
				if x.ActiveEnemy and s.Flashable(781--[[Disengage]]) and a.Castable["Disengage"]() then
					s.Flash(781--[[Disengage]], "Red")
				end
				if x.NoCC and s.Flashable(2973--[[Raptor Strike]]) and a.Castable["Raptor Strike"]() then
					s.Flash(2973--[[Raptor Strike]], SetColor(x.ActiveEnemy))
				elseif x.NoCC and not s.HasTalent(53295--[[Noxious Stings]]) and s.Flashable(1978--[[Serpent Sting]]) and a.Castable["Serpent Sting"]() then
					s.Flash(1978--[[Serpent Sting]], SetColor(x.ActiveEnemy))
				elseif x.NoCC and s.Flashable(3674--[[Black Arrow]]) and a.Castable["Black Arrow"]() then
					s.Flash(3674--[[Black Arrow]], SetColor(x.ActiveEnemy))
				elseif x.NoCC and s.TalentRank(53241--[[Marked for Death]]) == 2 and s.PowerPercent("player") > 66 and s.Flashable(3044--[[Arcane Shot]]) and EnoughForKillCommand(3044--[[Arcane Shot]]) and a.Castable["Arcane Shot"]() and not s.Debuff(1130--[[Hunter's Mark]]) and not s.Debuff(53241--[[Marked for Death]]) then
					s.Flash(3044--[[Arcane Shot]], SetColor(x.ActiveEnemy))
				elseif s.Flashable(1130--[[Hunter's Mark]]) and a.Castable["Hunter's Mark"]() then
					s.Flash(1130--[[Hunter's Mark]], SetColor(x.ActiveEnemy))
				else
					if x.ActiveEnemy and s.Flashable(82654--[[Widow Venom]]) and a.Castable["Widow Venom"]() then
						if s.Class(nil, HealingClasses) then
							s.Flash(82654--[[Widow Venom]], "Yellow")
						end
					end
					if x.NoCC and s.Flashable(3044--[[Arcane Shot]]) and s.PowerPercent("player") > 66 and EnoughForKillCommand(3044--[[Arcane Shot]]) and a.Castable["Arcane Shot"]() then
						s.Flash(3044--[[Arcane Shot]], SetColor(x.ActiveEnemy))
					else
						if s.TalentRank(53221--[[Improved Steady Shot]]) < 2 and x.NoCC and s.Flashable(77767--[[Cobra Shot]]) and a.Castable["Cobra Shot"]() then
							s.Flash(77767--[[Cobra Shot]], SetColor(x.ActiveEnemy))
						end
						if x.NoCC and s.Flashable(56641--[[Steady Shot]]) and a.Castable["Steady Shot"]() then
							s.Flash(56641--[[Steady Shot]], SetColor(x.ActiveEnemy))
						elseif x.ActiveEnemy and not s.Shooting() and not s.CurrentSpell(6603--[[Auto Attack]]) then
							if s.MeleeDistance() then
								if a.Castable["Auto Attack"]() then
									s.Flash(6603--[[Auto Attack]])
								end
							elseif a.Castable["Auto Shot"]() then
								s.Flash(75--[[Auto Shot]])
							end
						end
					end
				end
			end
		end
			--serpent Sting
			--Aimed Shot
			--Kill Shot
			
		end
		
		if s.TalentMastery(2) then -- MARKSMAN SLUUUTT
		PetStance()
		
		if x.PetAlive then
			
			if s.Flashable(136--[[Mend Pet]]) and a.Castable["Mend Pet"]() then
				s.Flash(136--[[Mend Pet]], SetColor(s.InCombat() or UnitExists("pettarget"), "Yellow", "Green"))
			end
			if x.PetActiveEnemy and s.Flashable(19574--[[Bestial Wrath]]) and a.Castable["Bestial Wrath"]() then
				s.Flash(19574--[[Bestial Wrath]], "Green")
			end
			if x.PetActiveEnemy and s.Flashable(19577--[[Intimidation]]) and a.Castable["Intimidation"]() then
				s.Flash(19577--[[Intimidation]], SetColor(s.GetCastingOrChanneling(nil, "pettarget", 1) > (s.SpellCooldown(19577--[[Intimidation]]) + x.DoubleLag), "Aqua"))
			end
			
		end
		
		if x.ActiveEnemy and s.Flashable(3045--[[Rapid Fire]]) and a.Castable["Rapid Fire"]() then
			s.Flash(3045--[[Rapid Fire]], "Green")
		end
		if s.Flashable(82692--[[Focus Fire]]) and a.Castable["Focus Fire"]() then
			s.Flash(82692--[[Focus Fire]], "Yellow")
		end
		if x.ActiveEnemy and s.Flashable(82726--[[Fervor]]) and a.Castable["Fervor"]() then
			s.Flash(82726--[[Fervor]], "Yellow")
		end
		if x.ActiveEnemy and s.Form(13165--[[Aspect of the Hawk]]) and a.Castable["Aspect of the Fox"]() then
			if s.Flashable(82661--[[Aspect of the Fox]]) then
				s.Flash(82661--[[Aspect of the Fox]], "Pink")
			end
			s.FlashForm(82661--[[Aspect of the Fox]], "Pink")
		elseif ( not s.Form() or ( x.ActiveEnemy and s.Form(82661--[[Aspect of the Fox]]) ) ) and a.Castable["Aspect of the Hawk"]() then
			if s.Flashable(13165--[[Aspect of the Hawk]]) then
				s.Flash(13165--[[Aspect of the Hawk]], SetColor(not s.Form(), "Green"))
			end
			s.FlashForm(13165--[[Aspect of the Hawk]], SetColor(not s.Form(), "Green"))
		end
		
		if s.Flashable(34490--[[Silencing Shot]]) and a.Castable["Silencing Shot"]() then
			s.Flash(34490--[[Silencing Shot]], "Aqua")
		elseif x.ActiveEnemy and s.Flashable(19503--[[Scatter Shot]]) and a.Castable["Scatter Shot"]() then
			if s.GetCastingOrChanneling(nil, nil, 1) > (s.SpellCooldown(19503--[[Scatter Shot]]) + x.DoubleLag) then
				s.Flash(19503--[[Scatter Shot]], "Aqua")
			elseif s.MeleeDistance() and not s.Feared() and not s.Rooted() then
				s.Flash(19503--[[Scatter Shot]], "Yellow")
			end
		end
		
		if x.NoCC and s.Flashable(56641--[[Steady Shot]]) and AddonTable.SecondSteadyShotReady() and a.Castable["Steady Shot"]() then
			s.Flash(56641--[[Steady Shot]], SetColor(x.ActiveEnemy, "Yellow"))
		end
		
		if ( not x.NoCC or not UnitIsPlayer(s.UnitSelection()) ) and not s.InCombat() and s.Flashable(1130--[[Hunter's Mark]]) and a.Castable["Hunter's Mark"]() then
			s.Flash(1130--[[Hunter's Mark]], "Green")
		elseif ( not x.NoCC or not UnitIsPlayer(s.UnitSelection()) ) and s.Flashable(1130--[[Hunter's Mark]]) and a.Castable["Hunter's Mark"]() then
			s.Flash(1130--[[Hunter's Mark]], SetColor(x.ActiveEnemy, "green"))
		end
		
		if x.NoCC and s.Flashable(19306--[[Counterattack]]) and a.Castable["Counterattack"]() then
				s.Flash(19306--[[Counterattack]], SetColor(x.ActiveEnemy))
			elseif x.NoCC and s.Flashable(2974--[[Wing Clip]]) and a.Castable["Wing Clip"]() then
				s.Flash(2974--[[Wing Clip]], SetColor(x.ActiveEnemy))
			else
				if x.ActiveEnemy and s.Flashable(781--[[Disengage]]) and a.Castable["Disengage"]() then
					s.Flash(781--[[Disengage]], "Red")
				end
		end
		
			if x.ActiveEnemy and s.Flashable(3045--[[Rapid Fire]]) and a.Castable["Rapid Fire"]() then
				s.Flash(3045--[[Rapid Fire]], "Green")
			elseif x.ActiveEnemy and s.Flashable(23989--[[Readiness]]) and not s.Buff(3045--[[Rapid Fire]], "player") and a.Castable["Readiness"]() then
				s.Flash(23989--[[Readiness]], "Green")
			end
			
			if x.NoCC and s.Flashable(56641--[[Steady Shot]]) and AddonTable.SecondSteadyShotReady() and a.Castable["Steady Shot"]() then
				s.Flash(56641--[[Steady Shot]], SetColor(x.ActiveEnemy, "Yellow"))
			end
			
			
			if s.Buff(32182--[[Heroism]], "player") or s.Buff(2825--[[Bloodlust]], "player") or s.Buff(80353--[[Time Warp]], "player") or s.Buff(3045--[[Rapid Fire]], "player") then
				if x.NoCC and s.Flashable(1978--[[Serpent Sting]]) and a.Castable["Serpent Sting"]() then
					s.Flash(1978--[[Serpent Sting]], SetColor(x.ActiveEnemy))
				elseif x.NoCC and s.Flashable(53209--[[Chimera Shot]]) and not s.MyDebuff(1978--[[Serpent Sting]], nil, 10) and a.Castable["Chimera Shot"]() then
					s.Flash(53209--[[Chimera Shot]], SetColor(x.ActiveEnemy))
				elseif x.NoCC and s.Flashable(19434--[[Aimed Shot]]) and s.Buff(82926--[[Fire!]], "Player") and a.Castable["Aimed Shot2"]() then
					s.Flash(19434--[[Aimed Shot]], SetColor(x.ActiveEnemy, "Yellow"))
				elseif x.NoCC and s.Flashable(19434--[[Aimed Shot]]) and a.Castable["Aimed Shot2"]() then
					s.Flash(19434--[[Aimed Shot]], SetColor(x.ActiveEnemy))
				elseif x.NoCC and s.Flashable(3044--[[Arcane Shot]]) and s.PowerPercent("player") > 80 and s.SpellCooldown(3674--[[Black Arrow]]) > 8 and a.Castable["Arcane Shot"]() then
					s.Flash(3044--[[Arcane Shot]], SetColor(x.ActiveEnemy))
				elseif x.NoCC and s.Flashable(3044--[[Arcane Shot]]) and s.PowerPercent("player") > 94 and a.Castable["Arcane Shot"]() then
					s.Flash(3044--[[Arcane Shot]], SetColor(x.ActiveEnemy))
				elseif x.NoCC and s.Flashable(56641--[[Steady Shot]]) and a.Castable["Steady Shot"]() then
					s.Flash(56641--[[Steady Shot]], SetColor(x.ActiveEnemy))
				end
			elseif x.NoCC and s.Flashable(1978--[[Serpent Sting]]) and a.Castable["Serpent Sting"]() then
				s.Flash(1978--[[Serpent Sting]], SetColor(x.ActiveEnemy))
			elseif x.NoCC and s.Flashable(53209--[[Chimera Shot]]) and not s.MyDebuff(1978--[[Serpent Sting]], nil, 10) and a.Castable["Chimera Shot"]() then
				s.Flash(53209--[[Chimera Shot]], SetColor(x.ActiveEnemy))
			elseif x.NoCC and s.Flashable(19434--[[Aimed Shot]]) and s.Buff(82926--[[Fire!]], "Player") and a.Castable["Aimed Shot2"]() then
					s.Flash(19434--[[Aimed Shot]], SetColor(x.ActiveEnemy, "Yellow"))
			--elseif x.NoCC and s.Flashable(19434--[[Aimed Shot]]) and a.Castable["Aimed Shot2"]() then
				--s.Flash(19434--[[Aimed Shot]], SetColor(x.ActiveEnemy))
			elseif x.NoCC and s.Flashable(3044--[[Arcane Shot]]) and s.PowerPercent("player") > 80 and s.SpellCooldown(3674--[[Black Arrow]]) > 8 and a.Castable["Arcane Shot"]() then
				s.Flash(3044--[[Arcane Shot]], SetColor(x.ActiveEnemy))
			elseif x.NoCC and s.Flashable(3044--[[Arcane Shot]]) and s.PowerPercent("player") > 66 and a.Castable["Arcane Shot"]() then
				s.Flash(3044--[[Arcane Shot]], SetColor(x.ActiveEnemy))
			elseif x.NoCC and s.Flashable(56641--[[Steady Shot]]) and a.Castable["Steady Shot"]() then
				s.Flash(56641--[[Steady Shot]], SetColor(x.ActiveEnemy))
			
			
			end
		
		end
		
		if s.TalentMastery(3) then -- SURVIVAL BIOTCH
		PetStance()
		
		if x.PetAlive then			
			
			if s.Flashable(136--[[Mend Pet]]) and a.Castable["Mend Pet"]() then
				s.Flash(136--[[Mend Pet]], SetColor(s.InCombat() or UnitExists("pettarget"), "Yellow", "Green"))
			end
			if x.PetActiveEnemy and s.Flashable(19574--[[Bestial Wrath]]) and a.Castable["Bestial Wrath"]() then
				s.Flash(19574--[[Bestial Wrath]], "Green")
			end
			if x.PetActiveEnemy and s.Flashable(19577--[[Intimidation]]) and a.Castable["Intimidation"]() then
				s.Flash(19577--[[Intimidation]], SetColor(s.GetCastingOrChanneling(nil, "pettarget", 1) > (s.SpellCooldown(19577--[[Intimidation]]) + x.DoubleLag), "Aqua"))
			end
			
		end
		
		if x.ActiveEnemy and s.Flashable(3045--[[Rapid Fire]]) and a.Castable["Rapid Fire"]() then
			s.Flash(3045--[[Rapid Fire]], "Green")
		end
		if s.Flashable(82692--[[Focus Fire]]) and a.Castable["Focus Fire"]() then
			s.Flash(82692--[[Focus Fire]], "Yellow")
		end
		if x.ActiveEnemy and s.Flashable(82726--[[Fervor]]) and a.Castable["Fervor"]() then
			s.Flash(82726--[[Fervor]], "Yellow")
		end
		if x.ActiveEnemy and s.Form(13165--[[Aspect of the Hawk]]) and a.Castable["Aspect of the Fox"]() then
			if s.Flashable(82661--[[Aspect of the Fox]]) then
				s.Flash(82661--[[Aspect of the Fox]], "Pink")
			end
			s.FlashForm(82661--[[Aspect of the Fox]], "Pink")
		elseif ( not s.Form() or ( x.ActiveEnemy and s.Form(82661--[[Aspect of the Fox]]) ) ) and a.Castable["Aspect of the Hawk"]() then
			if s.Flashable(13165--[[Aspect of the Hawk]]) then
				s.Flash(13165--[[Aspect of the Hawk]], SetColor(not s.Form(), "Green"))
			end
			s.FlashForm(13165--[[Aspect of the Hawk]], SetColor(not s.Form(), "Green"))
		end
		
		if s.Flashable(34490--[[Silencing Shot]]) and a.Castable["Silencing Shot"]() then
			s.Flash(34490--[[Silencing Shot]], "Aqua")
		elseif x.ActiveEnemy and s.Flashable(19503--[[Scatter Shot]]) and a.Castable["Scatter Shot"]() then
			if s.GetCastingOrChanneling(nil, nil, 1) > (s.SpellCooldown(19503--[[Scatter Shot]]) + x.DoubleLag) then
				s.Flash(19503--[[Scatter Shot]], "Aqua")
			elseif s.MeleeDistance() and not s.Feared() and not s.Rooted() then
				s.Flash(19503--[[Scatter Shot]], "Yellow")
			end
		end
		
		if x.NoCC and s.Flashable(56641--[[Steady Shot]]) and AddonTable.SecondSteadyShotReady() and a.Castable["Steady Shot"]() then
			s.Flash(56641--[[Steady Shot]], SetColor(x.ActiveEnemy, "Yellow"))
		end
		
		if ( not x.NoCC or not UnitIsPlayer(s.UnitSelection()) ) and not s.InCombat() and s.Flashable(1130--[[Hunter's Mark]]) and a.Castable["Hunter's Mark"]() then
			s.Flash(1130--[[Hunter's Mark]], "Green")
		elseif ( not x.NoCC or not UnitIsPlayer(s.UnitSelection()) ) and s.Flashable(1130--[[Hunter's Mark]]) and a.Castable["Hunter's Mark"]() then
			s.Flash(1130--[[Hunter's Mark]], SetColor(x.ActiveEnemy, "green"))
		end
		
		if x.NoCC and s.Flashable(19306--[[Counterattack]]) and a.Castable["Counterattack"]() then
				s.Flash(19306--[[Counterattack]], SetColor(x.ActiveEnemy))
			elseif x.NoCC and s.Flashable(2974--[[Wing Clip]]) and a.Castable["Wing Clip"]() then
				s.Flash(2974--[[Wing Clip]], SetColor(x.ActiveEnemy))
			else
				if x.ActiveEnemy and s.Flashable(781--[[Disengage]]) and a.Castable["Disengage"]() then
					s.Flash(781--[[Disengage]], "Red")
				end
		end

			if x.ActiveEnemy and s.Flashable(3045--[[Rapid Fire]]) and s.PowerPercent("player") < 35 and a.Castable["Rapid Fire"]() then
				s.Flash(3045--[[Rapid Fire]], "Green")
			end

			if x.NoCC and s.Flashable(1978--[[Serpent Sting]]) and a.Castable["Serpent Sting"]() then
				s.Flash(1978--[[Serpent Sting]], SetColor(x.ActiveEnemy))	
			elseif x.NoCC and s.Flashable(53301--[[Explosive Shot]]) and a.Castable["Explosive Shot"]() then
				s.Flash(53301--[[Explosive Shot]], SetColor(x.ActiveEnemy))
			elseif x.NoCC and s.Flashable(3044--[[Arcane Shot]]) and s.PowerPercent("player") > 66 and s.SpellCooldown(3674--[[Black Arrow]]) > 8 and a.Castable["Arcane Shot"]() then
				s.Flash(3044--[[Arcane Shot]], SetColor(x.ActiveEnemy))
			elseif x.NoCC and s.Flashable(3674--[[Black Arrow]]) and a.Castable["Black Arrow"]() then
				s.Flash(3674--[[Black Arrow]], SetColor(x.ActiveEnemy))
			elseif x.NoCC and s.Flashable(3044--[[Arcane Shot]]) and s.PowerPercent("player") > 79 and a.Castable["Arcane Shot"]() then
				s.Flash(3044--[[Arcane Shot]], SetColor(x.ActiveEnemy))
			elseif s.TalentRank(53221--[[Improved Steady Shot]]) < 2 and x.NoCC and s.Flashable(77767--[[Cobra Shot]]) and a.Castable["Cobra Shot"]() then
				s.Flash(77767--[[Cobra Shot]], SetColor(x.ActiveEnemy))
			end
		end
		

		
	end},
	
	
		-- Add and remove as many of these table sections ass needed
	{Title = L["Nothing"], -- Place script title here
	Description = L["Testing script"], -- Place optional script description here or comment out or remove this line
	Function = function()
		-- x.Enemy, x.ActiveEnemy, x.NoCC, x.InInstance, x.InstanceType, x.PetAlive, x.PetActiveEnemy, x.PetNoCC, x.Lag, x.DoubleLag, x.ThreatPercent
		
		
		
		
	end},
	
			-- Add and remove as many of these table sections ass needed
	{Title = L["No Priority"], -- Place script title here
	Description = L["This removes the priority Flashing."], -- Place optional script description here or comment out or remove this line
	Function = function()
		-- x.Enemy, x.ActiveEnemy, x.NoCC, x.InInstance, x.InstanceType, x.PetAlive, x.PetActiveEnemy, x.PetNoCC, x.Lag, x.DoubleLag, x.ThreatPercent
		


	end},
	
	
}

