﻿--[[	$Id: oUF_cDebuff.lua 2001 2011-01-31 16:26:33Z sdkyron@gmail.com $	]]

if not oUF then return end

local _, oUF_Caellian = ...

oUF_Caellian.eventFrame = CreateFrame("Frame", nil, UIParent)

local playerClass = caelLib.playerClass

local canDispel = {
	DRUID = {Curse = true, Poison = true},
	MAGE = {Curse = true},
	PALADIN = {Poison = true, Disease = true}, 
	PRIEST = {Disease = true, Magic = true},
	SHAMAN = {Curse = true}
}

oUF_Caellian.eventFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
oUF_Caellian.eventFrame:RegisterEvent("CHARACTER_POINTS_CHANGED")
oUF_Caellian.eventFrame:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
oUF_Caellian.eventFrame:SetScript("OnEvent", function()
    if playerClass == "DRUID" or playerClass == "PALADIN" or playerClass == "SHAMAN" then
        local tab, index

        if playerClass == "DRUID" then
            tab, index = 3, 17
        elseif playerClass == "PALADIN" then
            tab, index = 1, 14
        elseif playerClass == "SHAMAN" then
            tab, index = 3, 12
        end

        local _, _, _, _, rank = GetTalentInfo(tab, index)

        canDispel[playerClass].Magic = rank == 1 and true
    end
end)

local dispelList = canDispel[playerClass] or {}

local DebuffTypeColor = {}

for k, v in pairs(_G["DebuffTypeColor"]) do
	DebuffTypeColor[k] = v
end

local backupColor = {r = 0.69, g = 0.31, b = 0.31}

setmetatable(DebuffTypeColor, {__index = function() return backupColor end})

local GetSpellName = function(spellId)
	return GetSpellInfo(spellId)
end

local whiteList = {
--Baradin Hold
	[GetSpellName(88954)] = true, -- Consuming Darkness
--Blackwing Descent
	--Magmaw
	[GetSpellName(78941)] = true, -- Parasitic Infection
	[GetSpellName(89773)] = true, -- Mangle
	--Omnitron Defense System
	[GetSpellName(79888)] = true, -- Lightning Conductor
	[GetSpellName(79505)] = true, -- Flamethrower
	[GetSpellName(80161)] = true, -- Chemical Cloud
	[GetSpellName(79501)] = true, -- Acquiring Target
	[GetSpellName(80011)] = true, -- Soaked in Poison
	[GetSpellName(80094)] = true, -- Fixate
	--Maloriak
	[GetSpellName(92973)] = true, -- Consuming Flames
	[GetSpellName(92978)] = true, -- Flash Freeze
	[GetSpellName(91829)] = true, -- Fixate
	--Atramedes
	[GetSpellName(78092)] = true, -- Tracking
	[GetSpellName(78897)] = true, -- Noisy
	[GetSpellName(78023)] = true, -- Roaring Flame
	--Chimaeron
	[GetSpellName(89084)] = true, -- Low Health
	[GetSpellName(82881)] = true, -- Break
	[GetSpellName(82890)] = true, -- Mortality
	--Nefarian
	[GetSpellName(94128)] = true, -- Tail Lash
	[GetSpellName(94075)] = true, -- Magma
--The Bastion of Twilight
	--Halfus
	[GetSpellName(39171)] = true, -- Malevolent Strikes
	[GetSpellName(86169)] = true, -- Furious Roar
	--Valiona & Theralion
	[GetSpellName(86788)] = true, -- Blackout
	[GetSpellName(86622)] = true, -- Engulfing Magic
	[GetSpellName(86202)] = true, -- Twilight Shift
	--Council
	[GetSpellName(82665)] = true, -- Heart of Ice
	[GetSpellName(82660)] = true, -- Burning Blood
	[GetSpellName(82762)] = true, -- Waterlogged
	[GetSpellName(83099)] = true, -- Lightning Rod
	[GetSpellName(82285)] = true, -- Elemental Stasis
	[GetSpellName(92488)] = true, -- Gravity Well
	--Cho'gall
	[GetSpellName(86028)] = true, -- Cho's Blast
	[GetSpellName(86029)] = true, -- Gall's Blast
	[GetSpellName(93189)] = true, -- Corrupted Blood
	[GetSpellName(93133)] = true, -- Debilitating Beam
	[GetSpellName(81836)] = true, -- Corruption: Accelerated
	[GetSpellName(81831)] = true, -- Corruption: Sickness
	[GetSpellName(82125)] = true, -- Corruption: Malformation
	[GetSpellName(82170)] = true, -- Corruption: Absolute
--Throne of the Four Winds
	--Conclave
	[GetSpellName(85576)] = true, -- Withering Winds
	[GetSpellName(85573)] = true, -- Deafening Winds
	[GetSpellName(93057)] = true, -- Slicing Gale
	[GetSpellName(86481)] = true, -- Hurricane
	[GetSpellName(93123)] = true, -- Wind Chill
	[GetSpellName(93121)] = true, -- Toxic Spores
	--Al'Akir
	[GetSpellName(87873)] = true, -- Static Shock
	[GetSpellName(88427)] = true, -- Electrocute
	[GetSpellName(93294)] = true, -- Lightning Rod
	[GetSpellName(93284)] = true, -- Squall Line
}

local function GetDebuffType(unit, filter)
	if not UnitCanAssist("player", unit) then return end

	local dispelType, debuffIcon

	local i = 1
	local isWhiteList

	while true do
		local name, _, icon, _, debuffType = UnitAura(unit, i, "HARMFUL")

		if not icon then break end

		if dispelList[debuffType] or (not filter and debuffType) or whiteList[name] then

			dispelType = debuffType
			debuffIcon = icon

			if whiteList[name] then
				isWhiteList = true
				break
			end
		end

		i = i + 1
	end

	return dispelType, debuffIcon, isWhiteList
end

local function Update(self, event, unit)
	if self.unit ~= unit  then return end

	local dispelType, debuffIcon, isWhiteList = GetDebuffType(unit, self.cDebuffFilter)

	if self.cDebuffBackdrop then
		local color

		if debuffIcon then
			color = DebuffTypeColor[dispelType]
			self.cDebuffBackdrop:SetVertexColor(color.r, color.g, color.b, 1)
		else
			self.cDebuffBackdrop:SetVertexColor(0, 0, 0, 0)
		end
	end

	if self.cDebuff.icon then
		if debuffIcon then
			self.cDebuff.icon:SetTexture(debuffIcon)
			self.cDebuff.border:SetBackdropColor(0.5, 0.5, 0.5, 1)
			self.cDebuff.gloss:SetBackdropColor(0.25, 0.25, 0.25, 0.5)
		else
			self.cDebuff.icon:SetTexture(nil)
			self.cDebuff.border:SetBackdropColor(0.5, 0.5, 0.5, 0)
			self.cDebuff.gloss:SetBackdropColor(0.25, 0.25, 0.25, 0)
		end
	end
end

local function Enable(self)
	if not self.cDebuff then return end

	self:RegisterEvent("UNIT_AURA", Update)

	return true
end

local function Disable(self)
	if self.cDebuffBackdrop or self.cDebuff.icon then
		self:UnregisterEvent("UNIT_AURA", Update)
	end
end

oUF:AddElement("cDebuff", Update, Enable, Disable)